/******************************************************************************/
/*									      */
/*			  	I N C L U D E S			      	      */
/*									      */
/******************************************************************************/
#include <stdio.h>
#include <math.h>
#include <stdlib.h>
#include <dos.h>
#include <conio.h>
#include <i86.h>
#include <string.h>
#include "vesalint.h"
#include "example.h"

VOID	main(int argc, char *argv[])
{
	if(argc>=8)
	{
		Active.Screen.Width=atoi(argv[1]);
		Active.Screen.Height=atoi(argv[2]);
		Active.Screen.bpp=atoi(argv[3]);

		Active.Work.Width=atoi(argv[4]);
		Active.Work.Height=atoi(argv[5]);
		Active.Work.bpp=atoi(argv[6]);

		//if EnableLFB is TRUE, LFB is activated if available
		Active.EnableLFB=atoi(argv[7]); 
		
		if(Active.Work.bpp==8)
		{
			// 8 bpp: We work out the red,green & blue values we  
			//	  need for this effect, and write these values 
			//	  to the palette previously allocated.
				  
			Active.Palette=(COLOR*) malloc(256*sizeof(COLOR));
			PhongPal(0, 63, 0, 0, 4, 70, 85, 1);
			PhongPal(85, 0, 63, 0, 4, 70, 85, 0);
			PhongPal(170, 0, 0, 63, 4, 70, 86, 1);
		}
		
		if(InitSetMode())
		{
			WorkBuffer=(UBYTE *) malloc(Active.Work.ResolSize);
			if(WorkBuffer!=NULL)
			{
				if(Active.Work.bpp==8)  Example8();
				if(Active.Work.bpp==15) Example15();
				if(Active.Work.bpp==16) Example16();
				if(Active.Work.bpp==24) Example24();
			}
			else
			{
				Error_Code=1;
				ErrorMsg();
			}
		}
		if(!Free_Memory()) ErrorMsg();
		
		if(Active.Work.bpp==8)
		{
			free(Active.Palette);
		}		
	}
	else
	{
		printf("Use: example <xresol> <yresol> <bpp> <workxresol> <workyresol> <workbpp> <lfb>\n");
		printf("     (bpp=-1 for fake)\n");		
	}	
}

/******************************************************************************/
/*									      */
/*			  	 E X A M P L E 				      */
/*									      */
/******************************************************************************/
VOID	Example24() //24 bpp example
{
	UDWORD	*timer;
	UBYTE	comb;
	UWORD	x,y;
	UWORD	Red,Green,Blue;	
	SDWORD	iRl,iGl,iBl,iRr,iGr,iBr,dlR,dlG,dlB,drR,drG,drB,innerR,innerG,innerB,R,G,B;
	COLOR	p00,p01,p10,p11;
	UBYTE	cols[]={255,	  0,	  0,
			  0,	255,	  0,
			255,	255,	  0,

			255,	  0,	  0,
			  0,	  0,	255,
			255,	  0,	255,

			  0,	255,	  0,
			  0,	  0,	255,
			  0,	255,	255,
			
			  255,	  0,	  0,
			  0,	255,	  0,
			  0,	  0,	255
			};



        timer = (UDWORD *) 0x046c;
	srand(*timer);
	comb=rand()%4;

	p00.r=0;
	p00.g=0;
	p00.b=0;

	p01.r=cols[comb*9];
	p01.g=cols[comb*9+1];
	p01.b=cols[comb*9+2];

	p10.r=cols[comb*9+3];
	p10.g=cols[comb*9+3+1];
	p10.b=cols[comb*9+3+2];

	p11.r=cols[comb*9+6];
	p11.g=cols[comb*9+6+1];
	p11.b=cols[comb*9+6+2];



	InitFrames();
	while(!kbhit() && p00.r<256) 
	{
		dlR=65536*(p01.r-p00.r)/Active.Work.Height;
		dlG=65536*(p01.g-p00.g)/Active.Work.Height;
		dlB=65536*(p01.b-p00.b)/Active.Work.Height;

		iRl=65536*p00.r;
		iGl=65536*p00.g;
		iBl=65536*p00.b;
					
		drR=65536*(p11.r-p10.r)/Active.Work.Height;
		drG=65536*(p11.g-p10.g)/Active.Work.Height;
		drB=65536*(p11.b-p10.b)/Active.Work.Height;
	
		iRr=65536*p10.r;
		iGr=65536*p10.g;
		iBr=65536*p10.b;


		for(y=0;y<Active.Work.Height;++y)
		{	
			innerR=(iRr-iRl)/Active.Work.Width;
			innerG=(iGr-iGl)/Active.Work.Width;
			innerB=(iBr-iBl)/Active.Work.Width;
		
			R=iRl;
			G=iGl;
			B=iBl;

			for(x=0;x<Active.Work.Width;++x)
			{
				Red=R>>16;
				Green=G>>16;
				Blue=B>>16;
					
				WorkBuffer[(y*Active.Work.Width+x)*3]=Blue&0xff; // First the blue value
				WorkBuffer[(y*Active.Work.Width+x)*3+1]=Green&0xff; //Then the green value
				WorkBuffer[(y*Active.Work.Width+x)*3+2]=Red&0xff; //Finally the red value

				R+=innerR;
				G+=innerG;
				B+=innerB;
			}
			iRl+=dlR;
			iGl+=dlG;
			iBl+=dlB;
					
			iRr+=drR;
			iGr+=drG;
			iBr+=drB;
		}
		Flip(WorkBuffer);
                Sincro();
		++p00.r;
		++p00.g;
		++p00.b;
		++conta;
	}
        EndFrames();
	getch();

	Set_Mode(0x3);
        PrintFrames();
}


VOID	Example16()	//16 bpp example
{
	UDWORD	*timer;
	UBYTE	comb;
	UWORD	x,y;
	UWORD	Red,Green,Blue;	
	SDWORD	iRl,iGl,iBl,iRr,iGr,iBr,dlR,dlG,dlB,drR,drG,drB,innerR,innerG,innerB,R,G,B;
	COLOR 	p00,p01,p10,p11;
	UWORD	*WorkBufferW;
	UBYTE	cols[]={ 31,	  0,	  0,
			  0,	 63,	  0,
			 31,	 63,	  0,

			 31,	  0,	  0,
			  0,	  0,	 31,
			 31,	  0,	 31,

			  0,	 63,	  0,
			  0,	  0,	 31,
			  0,	 63,	 31,
			
			  31,	  0,	  0,
			  0,	 63,	  0,
			  0,	  0,	 31
			};



        timer = (UDWORD *) 0x046c;
	srand(*timer);
	comb=rand()%4;

	p00.r=0;
	p00.g=0;
	p00.b=0;

	p01.r=cols[comb*9];
	p01.g=cols[comb*9+1];
	p01.b=cols[comb*9+2];

	p10.r=cols[comb*9+3];
	p10.g=cols[comb*9+3+1];
	p10.b=cols[comb*9+3+2];

	p11.r=cols[comb*9+6];
	p11.g=cols[comb*9+6+1];
	p11.b=cols[comb*9+6+2];


	WorkBufferW=(UWORD*) WorkBuffer;

	InitFrames();
	while(!kbhit() && p00.r<32) 
	{
		dlR=65536*(p01.r-p00.r)/Active.Work.Height;
		dlG=65536*(p01.g-p00.g)/Active.Work.Height;
		dlB=65536*(p01.b-p00.b)/Active.Work.Height;

		iRl=65536*p00.r;
		iGl=65536*p00.g;
		iBl=65536*p00.b;
					
		drR=65536*(p11.r-p10.r)/Active.Work.Height;
		drG=65536*(p11.g-p10.g)/Active.Work.Height;
		drB=65536*(p11.b-p10.b)/Active.Work.Height;
	
		iRr=65536*p10.r;
		iGr=65536*p10.g;
		iBr=65536*p10.b;


		for(y=0;y<Active.Work.Height;++y)
		{	
			innerR=(iRr-iRl)/Active.Work.Width;
			innerG=(iGr-iGl)/Active.Work.Width;
			innerB=(iBr-iBl)/Active.Work.Width;

			R=iRl;
			G=iGl;
			B=iBl;

			for(x=0;x<Active.Work.Width;++x)
			{
				Red=R>>16;
				Green=G>>16;
				Blue=B>>16;
					
				//RRRRRGGGGGGBBBBB
				//|   ........   |
				//15		 0    bit
				WorkBufferW[(y*Active.Work.Width+x)]=Blue+(Green<<5)+(Red<<11);
		
				R+=innerR;
				G+=innerG;
				B+=innerB;
			}
			iRl+=dlR;
			iGl+=dlG;
			iBl+=dlB;
					
			iRr+=drR;
			iGr+=drG;
			iBr+=drB;
		}
		Flip(WorkBuffer);
                Sincro();
		++p00.r;
		p00.g+=2;
		++p00.b;
		++conta;
	}
        EndFrames();
	getch();

	Set_Mode(0x3);
        PrintFrames();
}

VOID	Example15()	//15 bpp example
{
	UDWORD	*timer;
	UBYTE	comb;
	UWORD	x,y;
	UWORD	Red,Green,Blue;	
	SDWORD	iRl,iGl,iBl,iRr,iGr,iBr,dlR,dlG,dlB,drR,drG,drB,innerR,innerG,innerB,R,G,B;
	COLOR 	p00,p01,p10,p11;
	UWORD	*WorkBufferW;
	UBYTE	cols[]={ 31,	  0,	  0,
			  0,	 31,	  0,
			 31,	 31,	  0,

			 31,	  0,	  0,
			  0,	  0,	 31,
			 31,	  0,	 31,

			  0,	 31,	  0,
			  0,	  0,	 31,
			  0,	 31,	 31,
			
			  31,	  0,	  0,
			  0,	 31,	  0,
			  0,	  0,	 31
			};



        timer = (UDWORD *) 0x046c;
	srand(*timer);
	comb=rand()%4;

	p00.r=0;
	p00.g=0;
	p00.b=0;

	p01.r=cols[comb*9];
	p01.g=cols[comb*9+1];
	p01.b=cols[comb*9+2];

	p10.r=cols[comb*9+3];
	p10.g=cols[comb*9+3+1];
	p10.b=cols[comb*9+3+2];

	p11.r=cols[comb*9+6];
	p11.g=cols[comb*9+6+1];
	p11.b=cols[comb*9+6+2];


	WorkBufferW=(UWORD*) WorkBuffer;

	InitFrames();
	while(!kbhit() && p00.r<32) 
	{
		dlR=65536*(p01.r-p00.r)/Active.Work.Height;
		dlG=65536*(p01.g-p00.g)/Active.Work.Height;
		dlB=65536*(p01.b-p00.b)/Active.Work.Height;

		iRl=65536*p00.r;
		iGl=65536*p00.g;
		iBl=65536*p00.b;
					
		drR=65536*(p11.r-p10.r)/Active.Work.Height;
		drG=65536*(p11.g-p10.g)/Active.Work.Height;
		drB=65536*(p11.b-p10.b)/Active.Work.Height;
	
		iRr=65536*p10.r;
		iGr=65536*p10.g;
		iBr=65536*p10.b;


		for(y=0;y<Active.Work.Height;++y)
		{	
			innerR=(iRr-iRl)/Active.Work.Width;
			innerG=(iGr-iGl)/Active.Work.Width;
			innerB=(iBr-iBl)/Active.Work.Width;

			R=iRl;
			G=iGl;
			B=iBl;

			for(x=0;x<Active.Work.Width;++x)
			{
				Red=R>>16;
				Green=G>>16;
				Blue=B>>16;

				//XRRRRRGGGGGBBBBB
				//|   ........   |
				//15		 0    bit
					
				WorkBufferW[(y*Active.Work.Width+x)]=Blue+(Green<<5)+(Red<<10);
		
				R+=innerR;
				G+=innerG;
				B+=innerB;
			}
			iRl+=dlR;
			iGl+=dlG;
			iBl+=dlB;
					
			iRr+=drR;
			iGr+=drG;
			iBr+=drB;
		}
		Flip(WorkBuffer);
                Sincro();
		++p00.r;
		++p00.g;
		++p00.b;
		++conta;
	}
        EndFrames();
	getch();

	Set_Mode(0x3);
        PrintFrames();
}


VOID	Example8()	//8 bpp example
{
	UWORD	x,y;
	SDWORD	il,ir,dl,dr,inner;
	UDWORD	col,c;
	UWORD 	p00,p01,p10,p11;


	p00=0;
	p10=85;
	p01=170;
	p11=255;

	InitFrames();
	while(!kbhit() && p00<255) 
	{
		dl=65536*(p01-p00)/Active.Work.Height;

		il=65536*p00;
					
		dr=65536*(p11-p10)/Active.Work.Height;
	
		ir=65536*p10;

		for(y=0;y<Active.Work.Height;++y)
		{	
			inner=(ir-il)/Active.Work.Width;

			col=il;

			for(x=0;x<Active.Work.Width;++x)
			{
				c=col>>16;
				WorkBuffer[(y*Active.Work.Width+x)]=c;
				col+=inner;
			}
			il+=dl;
			ir+=dr;
		}
		Flip(WorkBuffer);
                Sincro();
		++p00;
		++conta;
	}
        EndFrames();
	getch();

	Set_Mode(0x3);
        PrintFrames();
}

/******************************************************************************/
/*									      */
/*	     F R A M E S    P E R    S E C O N D    F U N C T I O N S         */
/*									      */
/******************************************************************************/
VOID	InitFrames()
{
        timer = (UDWORD *) 0x046c;
        tIn = *timer;
        conta=0;
}

VOID	EndFrames()
{
        tOut = *timer;
}

VOID	PrintFrames()
{
        printf("%f fps\n", (float) ((conta * 18.2) / (tOut - tIn)));
}

#pragma	aux Set_Mode=\
"int	10h"\
modify	[ax]\
parm	[ax]

VOID	PhongPal(UBYTE InitCol, UWORD Red, UWORD Green, UWORD Blue, UWORD Reflect, UWORD Light, UWORD NumColors, UWORD Direction)
{
	UWORD	conta, temp;
	float   i,j;

	for (conta=0;conta<NumColors;++conta)
	{
		if(Direction) i=sin(conta*PI/(2*NumColors));
		if(!Direction) i=cos(conta*PI/(2*NumColors));
		j=pow(i,Reflect)*Light;
		temp=Red*i+j;
		if(temp>63) temp=63;
		Active.Palette[InitCol+conta].r=temp;
		temp=Green*i+j;
		if(temp>63) temp=63;
		Active.Palette[InitCol+conta].g=temp;
		temp=Blue*i+j;
		if(temp>63) temp=63;
		Active.Palette[InitCol+conta].b=temp;
	}
}

VOID	Sincro()
{
	while((inp(0x3da)&8)!=0);
	while((inp(0x3da)&8)==0);
}
