#include <stdio.h>
#include <conio.h>
#include <i86.h>
#include "vesalint.h"

VOID	ShowCursor();
VOID	HideCursor();
VOID	Gotoxy(UBYTE x, UBYTE y);
VOID	Set_Mode(UWORD Mode);

#define	UP	72
#define	DOWN	80
#define	LEFT	75
#define	RIGHT	77
#define	ENTER	13
#define	ESCAPE	27
#define HOME	71
#define END	79
BOOL	Choice(UWORD MinX, UWORD MinY, UWORD MaxX, UWORD MaxY, UWORD *opt);
extern	MODE	Vesa_Modes[256];

#pragma aux Gotoxy=\
" MOV AH,2 "\
" MOV BH,0 "\
" INT 10H  "\
modify [eax ebx edx]\
parm [dl] [dh];

#pragma	aux Set_Mode=\
"int	10h"\
modify	[ax]\
parm	[ax]


BOOL	Choice(UWORD MinX, UWORD MinY, UWORD MaxX, UWORD MaxY, UWORD *opt)
{
	UWORD	x,y,c,oy,ox,n;
	UBYTE	key;
	BOOL	finish=FALSE;
	BOOL	nret,draw=TRUE;
	SWORD	choice;

	Get_Vesa_Info();
	Get_Modes_Info();

	Set_Mode(0x3);

	HideCursor();
	DrawBox(MinX,MinY,MaxX,MaxY);
	x=MinX+2;
	y=MinY+1;

	c=0;
	while(Vesa_Modes[c].Mode!=-1)
	{
		Gotoxy(x,y);
	
		cprintf("%ux%ux%u\n",Vesa_Modes[c].Width,
				   Vesa_Modes[c].Height,
				   Vesa_Modes[c].bpp);
		++y;
		if(y%MaxY==0)
		{
			y=MinY+1;
			x+=14;			
		}
		++c;
	}
	c--;
	while(kbhit()) getch();

	if(opt==NULL)
	{
		ox=x=MinX+1;
		oy=y=MinY+1;
		choice=0;
	}
	else
	{
		choice=*opt;
		if(choice>c) choice=c;
		ox=x=MinX+14*(choice/(MaxY-MinY-1))+1;
		oy=y=MinY+choice%(MaxY-MinY-1)+1;
	}


	do
	{
		if(draw)
		{
			Gotoxy(ox,oy);
			cprintf(" ");

			Gotoxy(x,y);
			cprintf("");
			ox=x;
			oy=y;
		}
		key=getch();
		if(key==0) key=getch();

		draw=TRUE;

		switch(key)
		{	
			case	UP:
				if(choice>0)
				{
					if(y>MinY+1){
						--y;
						--choice;
					}
					else
					{
						y=MaxY-1;
						x-=14;
						--choice;
					}
				}
				else
				{
					beep();
					draw=FALSE;
				}
				break;

			case	DOWN:
				if(choice<c)
				{
					if(y<MaxY-1){
						++y;
						++choice;
					}
					else
					{
						y=MinY+1;
						x+=14;
						++choice;
					}
				}
				else
				{
					beep();
					draw=FALSE;
				}
				break;

			case	RIGHT:
					n=MaxY-MinY-1;
					x+=14;
					choice+=n;
					if(choice>c)
					{
						choice=c;
						x=MinX+14*(c/(MaxY-MinY-1))+1;
						y=MinY+c%(MaxY-MinY-1)+1;
					}
				break;

			case	LEFT:
					n=MaxY-MinY-1;
					x-=14;
					choice-=n;
					if(choice<0)
					{
						choice=0;
						x=MinX+1;
						y=MinY+1;
					}
				break;

			case	HOME:
					choice=0;
					x=MinX+1;
					y=MinY+1;
				break;

			case	END:
					choice=c;
					y=MinY+c%(MaxY-MinY-1)+1;
					x=MinX+14*(c/(MaxY-MinY-1))+1;
				break;

			case	ENTER:
				nret=TRUE;
				finish=TRUE;
				break;	

			case	ESCAPE:
				nret=FALSE;
				finish=TRUE;
				break;

			default:
				beep();	
				draw=FALSE;
		}
	}while(!finish);
	*opt=choice;
	ShowCursor();
	return(nret);
}

VOID	DrawBox(UWORD MinX, UWORD MinY, UWORD MaxX, UWORD MaxY)
{
	UWORD	x,y;

	x=MinX+1;
	y=MinY;
	Gotoxy(x,y);

	for(x=MinX+1;x<MaxX;++x)
	{
		cprintf("");
	}
	
	x=MinX+1;
	y=MaxY;
	Gotoxy(x,y);

	for(x=MinX+1;x<MaxX;++x)
	{
		cprintf("");
	}


	x=MinX;
	for(y=MinY+1;y<MaxY;++y)
	{
		Gotoxy(x,y);
		cprintf("");
	}

	x=MaxX;
	for(y=MinY+1;y<MaxY;++y)
	{
		Gotoxy(x,y);
		cprintf("");
	}

	Gotoxy(MinX,MinY);
	cprintf("");

	Gotoxy(MaxX,MinY);
	cprintf("");

	Gotoxy(MinX,MaxY);
	cprintf("");

	Gotoxy(MaxX,MaxY);
	cprintf("");
}

VOID	beep()
{
	sound(20000);
	delay(200);
	nosound();
}

#pragma	aux HideCursor=\
"mov	ah,1"\
"mov	cx,0x2000"\
"int	10h"\
modify	[ax cx];

#pragma	aux ShowCursor=\
"mov	ah,1"\
"mov	cx,0x0607"\
"int	10h"\
modify	[ax cx];
