/******************************************************************************/
/*									      */
/*			    Vesa Library v1.1b 			      */
/*			     Optimized C version	 	      	      */
/*	Tab Size	: 8						      */
/*	Author		: Enric Agut					      */
/*	Nick   		: Dr. Pitch of SAVAGE				      */
/*	Date (Start)	: 05/9/98					      */
/*	Date (End)  	: 05/10/98					      */
/*	Comments 	: Altough this library is freeware, mail me if you    */
/*			  want to use it for your demos, utilities, games,... */
/*	Any suggestions (or any bug of this program) can be sent to: 	      */
/*		e7634217@est.fib.upc.es					      */
/*	Compiler & Linker : Watcom v10.5				      */
/*									      */
/*	Greetings jump to: all Savage members (Blue Phantom, Dr.Pain, FloOd,  */
/*	CCM, Smash!, Madknight & Wonder), Dr. Kami, Marathon Man, Falcon,     */
/*	Yacare, Sairf, Wally, Astharoth, ChC & Skirep.			      */
/*									      */
/*	Special thanks to:  Babyloon / Revelation; Blue Phantom / Savage;     */
/*	& Phil Jones							      */
/*									      */
/******************************************************************************/
#define __TRNSFORM
#include <stdio.h>
#include <stdlib.h>
#include <dos.h>
#include <conio.h>
#include <i86.h>
#include <string.h>
#include "vesalint.h"

/******************************************************************************/
/*									      */
/*	 B I T S    P E R    P I X E L    T R A N S F O R M A T I O N S       */
/*									      */
/******************************************************************************/
VOID	Transform_bpp(UWORD Workbpp, UWORD Screenbpp, UBYTE *WorkBuffer, UBYTE *ScreenBuffer)
{
	switch(Workbpp)
	{
		case	24:
			if(Screenbpp==32) Bpp24to32(WorkBuffer,ScreenBuffer);
			if(Screenbpp==24) Scale24(WorkBuffer,ScreenBuffer);
                        if(Screenbpp==16) Bpp24to16(WorkBuffer,ScreenBuffer);
			if(Screenbpp==15) Bpp24to15(WorkBuffer,ScreenBuffer);
			if(Screenbpp==8) Bpp24to8(WorkBuffer,ScreenBuffer);
			if(Screenbpp==FAKEMODE) Bpp24toFake(WorkBuffer,ScreenBuffer);
			break;

		case	16:
			if(Screenbpp==32) Bpp16to32(WorkBuffer,ScreenBuffer);
			if(Screenbpp==24) Bpp16to24(WorkBuffer,ScreenBuffer);
			if(Screenbpp==16) Scale16(WorkBuffer,ScreenBuffer);
			if(Screenbpp==15) Bpp16to15(WorkBuffer,ScreenBuffer);
			if(Screenbpp==8) Bpp16to8(WorkBuffer,ScreenBuffer);
			if(Screenbpp==FAKEMODE) Bpp16toFake(WorkBuffer,ScreenBuffer);
			break;

		case	15:
			if(Screenbpp==32) Bpp15to32(WorkBuffer,ScreenBuffer);
			if(Screenbpp==24) Bpp15to24(WorkBuffer,ScreenBuffer);
                        if(Screenbpp==16) Bpp15to16(WorkBuffer,ScreenBuffer);
			if(Screenbpp==15) Scale15(WorkBuffer,ScreenBuffer);
			if(Screenbpp==8) Bpp15to8(WorkBuffer,ScreenBuffer);
			if(Screenbpp==FAKEMODE) Bpp15toFake(WorkBuffer,ScreenBuffer);
			break;

		case	8:
			if(Screenbpp==32) Bpp8to32(WorkBuffer,ScreenBuffer);
			if(Screenbpp==24) Bpp8to24(WorkBuffer,ScreenBuffer);
			if(Screenbpp==16) Bpp8to16(WorkBuffer,ScreenBuffer);
			if(Screenbpp==15) Bpp8to15(WorkBuffer,ScreenBuffer);
			if(Screenbpp==8) Scale8(WorkBuffer,ScreenBuffer);
			break;	//...
	}
}

static VOID    Bpp24to32(UBYTE *WorkBuffer, UBYTE *ScreenBuffer)
{
        UDWORD  WorkSize=(Active.Work.Width*Active.Work.Height*Active.Work.bpp)>>3;
	UBYTE	BlueShft,GreenShft,RedShft;
        UDWORD  Pos,XPos,YPos,XPos2,YPos2,PosdX,PosdY;

	BlueShft=Active.BlueShift>>3;
	GreenShft=Active.GreenShift>>3;
	RedShft=Active.RedShift>>3;

	if(Active.XRatio==65536 && Active.YRatio==65536)
	{
	        for(Pos=0;Pos<WorkSize;Pos+=3)
        	{
        	        ScreenBuffer[Pos+BlueShft]=WorkBuffer[Pos];    //Blue
                	ScreenBuffer[Pos+GreenShft]=WorkBuffer[Pos+1]; //Green
	                ScreenBuffer[Pos+RedShft]=WorkBuffer[Pos+2];   //Red
			ScreenBuffer++;
		}
        }
	else
	{
		YPos2=0;
		Pos=0;
	        for(YPos=0;YPos<Active.Screen.Height;YPos++)
		{
			PosdY=(YPos2>>16)*Active.Work.Width*3;
			XPos2=0;
			WorkBuffer+=PosdY;
		        for(XPos=0;XPos<Active.Screen.Width;XPos++)
		        {
				PosdX=(XPos2>>16)*3;
	        	        ScreenBuffer[Pos+BlueShft]=WorkBuffer[PosdX];   //Blue
	        	        ScreenBuffer[Pos+GreenShft]=WorkBuffer[PosdX+1];//Green
	        	        ScreenBuffer[Pos+RedShft]=WorkBuffer[PosdX+2];  //Red
				Pos+=4;
				XPos2+=Active.XRatio;
			}
			WorkBuffer-=PosdY;
			YPos2+=Active.YRatio;
		}
	}
}

static VOID    Bpp24to16(UBYTE *WorkBuffer, UBYTE *ScreenBuffer)
{
        UDWORD  WorkSize=Active.Screen.Width*Active.Screen.Height;
        UBYTE   Red,Green,Blue;
        UDWORD  Pos,XPos,YPos,XPos2,YPos2,PosdX,PosdY,Pos3;
	UWORD	*ScreenBufferW;

	ScreenBufferW=(UWORD*)ScreenBuffer;

	if(Active.XRatio==65536 && Active.YRatio==65536)
	{
		Pos3=0;
	        for(Pos=0;Pos<WorkSize;Pos++)
	        {
			Blue=WorkBuffer[Pos3];
			Green=WorkBuffer[Pos3+1];
			Red=WorkBuffer[Pos3+2];
			ScreenBufferW[Pos]=Palette16bpp[Green+(Red<<8)]+(Blue>>3);
			Pos3+=3;
		}
	}
	else
	{
		YPos2=0;
		Pos=0;
	        for(YPos=0;YPos<Active.Screen.Height;YPos++)
		{
			PosdY=(YPos2>>16)*Active.Work.Width*3;
			XPos2=0;
			WorkBuffer+=PosdY;
		        for(XPos=0;XPos<Active.Screen.Width;XPos++)
		        {
				PosdX=(XPos2>>16)*3;
				Blue=WorkBuffer[PosdX];
				Green=WorkBuffer[PosdX+1];
				Red=WorkBuffer[PosdX+2];
				ScreenBufferW[Pos]=Palette16bpp[Green+(Red<<8)]+(Blue>>3);
				++Pos;
				XPos2+=Active.XRatio;
			}
			WorkBuffer-=PosdY;
			YPos2+=Active.YRatio;
		}
	}
}


static VOID    Bpp24to15(UBYTE *WorkBuffer, UBYTE *ScreenBuffer)
{
	UDWORD  WorkSize=Active.Work.Width*Active.Work.Height;
        UBYTE   Red,Green,Blue;
        UDWORD  Pos,XPos,YPos,XPos2,YPos2,PosdX,PosdY,Pos3;
	UWORD	*ScreenBufferW;

	ScreenBufferW=(UWORD*)ScreenBuffer;

	if(Active.XRatio==65536 && Active.YRatio==65536)
	{
		Pos3=0;
	        for(Pos=0;Pos<WorkSize;Pos++)
	        {
			Blue=WorkBuffer[Pos3];
			Green=WorkBuffer[Pos3+1];
			Red=WorkBuffer[Pos3+2];
			ScreenBufferW[Pos]=Palette15bpp[Green+(Red<<8)]+(Blue>>3);
			Pos3+=3;
		}
	}
	else
	{
		YPos2=0;
		Pos=0;
	        for(YPos=0;YPos<Active.Screen.Height;YPos++)
		{
			PosdY=(YPos2>>16)*Active.Work.Width*3;
			XPos2=0;
			WorkBuffer+=PosdY;
		        for(XPos=0;XPos<Active.Screen.Width;XPos++)
		        {
				PosdX=(XPos2>>16)*3;
				Blue=WorkBuffer[PosdX];
				Green=WorkBuffer[PosdX+1];
				Red=WorkBuffer[PosdX+2];
				ScreenBufferW[Pos]=Palette15bpp[Green+(Red<<8)]+(Blue>>3);
				++Pos;
				XPos2+=Active.XRatio;
			}
			WorkBuffer-=PosdY;
			YPos2+=Active.YRatio;
		}
	}
}

static VOID    Bpp24to8(UBYTE *WorkBuffer, UBYTE *ScreenBuffer)
{
	UDWORD  WorkSize=Active.Work.Width*Active.Work.Height;
        UBYTE   Red,Green,Blue;
        UDWORD  Pos,XPos,YPos,XPos2,YPos2,PosdX,PosdY,Pos3;

	if(Active.XRatio==65536 && Active.YRatio==65536)
	{
		Pos3=0;
	        for(Pos=0;Pos<WorkSize;Pos++)
	        {
			Blue=WorkBuffer[Pos3]>>2;
			Green=WorkBuffer[Pos3+1]>>2;
			Red=WorkBuffer[Pos3+2]>>2;
			ScreenBuffer[Pos]=Palette8bpp[Red+(Green<<6)+(Blue<<12)];
			Pos3+=3;
		}
	}
	else
	{
		YPos2=0;
		Pos=0;
	        for(YPos=0;YPos<Active.Screen.Height;YPos++)
		{
			PosdY=(YPos2>>16)*Active.Work.Width*3;
			XPos2=0;
			WorkBuffer+=PosdY;
		        for(XPos=0;XPos<Active.Screen.Width;XPos++)
		        {
				PosdX=(XPos2>>16)*3;
				Blue=WorkBuffer[PosdX]>>2;
				Green=WorkBuffer[PosdX+1]>>2;
				Red=WorkBuffer[PosdX+2]>>2;
				ScreenBuffer[Pos]=Palette8bpp[Red+(Green<<6)+(Blue<<12)];
				++Pos;
				XPos2+=Active.XRatio;
			}
			WorkBuffer-=PosdY;
			YPos2+=Active.YRatio;
		}
	}
}

static VOID    Bpp24toFake(UBYTE *WorkBuffer, UBYTE *ScreenBuffer)
{
        UBYTE   Red,Blue;
        UDWORD  Pos,Pos2,XPos,YPos,XPos2,YPos2,PosdX,PosdY;
	UWORD	x,y;
	UBYTE	*ScreenBuff2;

	ScreenBuff2=ScreenBuffer+Active.Screen.Width;
	Pos=0;
	Pos2=0;

	if(FakeMode==m320x400 || FakeMode==m320x480)
	{
		if(Active.XRatio==65536 && Active.YRatio==65536)
		{
		        for(y=0;y<Active.Work.Height;y++)
			{
			        for(x=0;x<Active.Work.Width;x++)
        			{
					Blue=WorkBuffer[Pos2];
					Red=WorkBuffer[Pos2+2];
					ScreenBuffer[Pos]=PaletteFake[Red+(Blue<<8)];
					ScreenBuff2[Pos]=WorkBuffer[Pos2+1]>>2; //Green
					++Pos;
					Pos2+=3;
				}
			Pos+=Active.Work.Width;
			}
		}
		else
		{
			YPos2=0;
			Pos=0;
	        	for(YPos=0;YPos<Active.Screen.Height/2;YPos++)
			{
				PosdY=(YPos2>>16)*Active.Work.Width*3;
				WorkBuffer+=PosdY;
				XPos2=0;
		        	for(XPos=0;XPos<Active.Screen.Width;XPos++)
			        {
					PosdX=(XPos2>>16)*3;
					Blue=WorkBuffer[PosdX];
					Red=WorkBuffer[PosdX+2];
					ScreenBuffer[Pos]=PaletteFake[Red+(Blue<<8)];
					ScreenBuff2[Pos]=WorkBuffer[PosdX+1]>>2; //Green
					++Pos;
					XPos2+=Active.XRatio;
				}
				WorkBuffer-=PosdY;
				Pos+=Active.Screen.Width;
				YPos2+=Active.YRatio;
			}
		}
	}
	else if(FakeMode==m640x400 || FakeMode==m640x480)
	{
		if(Active.XRatio==65536 && Active.YRatio==65536)
		{
		        for(y=0;y<Active.Work.Height;y++)
			{
			        for(x=0;x<Active.Work.Width;x++)
        			{
					Blue=WorkBuffer[Pos2];
					Red=WorkBuffer[Pos2+2];
					ScreenBuffer[Pos]=PaletteFake[Red+(Blue<<8)];
					ScreenBuffer[Pos+1]=WorkBuffer[Pos2+1]>>2; //Green
					Pos+=2;
					Pos2+=3;
				}
			}
		}
		else
		{
			YPos2=0;
			Pos=0;
	        	for(YPos=0;YPos<Active.Screen.Height;YPos++)
			{
				PosdY=(YPos2>>16)*Active.Work.Width*3;
				XPos2=0;
				WorkBuffer+=PosdY;
		        	for(XPos=0;XPos<Active.Screen.Width/2;XPos++)
			        {
					PosdX=(XPos2>>16)*3;
					Blue=WorkBuffer[PosdX];
					Red=WorkBuffer[PosdX+2];
					ScreenBuffer[Pos]=PaletteFake[Red+(Blue<<8)];
					ScreenBuffer[Pos+1]=WorkBuffer[PosdX+1]>>2; //Green
					Pos+=2;
					XPos2+=Active.XRatio;
				}
				WorkBuffer-=PosdY;
				YPos2+=Active.YRatio;
			}
		}
	}
}


static VOID    Bpp16to32(UBYTE *WorkBuffer, UBYTE *ScreenBuffer)
{
	UDWORD  WorkSize=Active.Work.Width*Active.Work.Height;
        UDWORD  Pos,Pos2,XPos,YPos,XPos2,YPos2,PosdY;
	UBYTE	BlueShft,GreenShft,RedShft;
	UWORD	*WorkBufferW;
	UWORD	indx;

	BlueShft=Active.BlueShift>>3;
	GreenShft=Active.GreenShift>>3;
	RedShft=Active.RedShift>>3;

	WorkBufferW=(UWORD*) WorkBuffer;

	if(Active.XRatio==65536 && Active.YRatio==65536)
	{
		Pos2=0;
	        for(Pos=0;Pos<WorkSize;Pos++)
	        {
			indx=WorkBufferW[Pos];
        	        ScreenBuffer[Pos2+BlueShft]=Palette32bppBlue[indx];
        	        ScreenBuffer[Pos2+GreenShft]=Palette32bppGreen[indx];
        	        ScreenBuffer[Pos2+RedShft]=Palette32bppRed[indx];
			Pos2+=4;
		}
	}
	else
	{
		Pos2=0;
		YPos2=0;
        	for(YPos=0;YPos<Active.Screen.Height;YPos++)
		{
			PosdY=(YPos2>>16)*Active.Work.Width;
			XPos2=0;
			WorkBufferW+=PosdY;
	        	for(XPos=0;XPos<Active.Screen.Width;XPos++)
		        {
				indx=WorkBufferW[XPos2>>16];
		       	        ScreenBuffer[Pos2+BlueShft]=Palette32bppBlue[indx];
        		        ScreenBuffer[Pos2+GreenShft]=Palette32bppGreen[indx];
        	        	ScreenBuffer[Pos2+RedShft]=Palette32bppRed[indx];
				Pos2+=4;
				XPos2+=Active.XRatio;
			}
			WorkBufferW-=PosdY;
			YPos2+=Active.YRatio;
		}
	}
}

static VOID    Bpp16to24(UBYTE *WorkBuffer, UBYTE *ScreenBuffer)
{
	UDWORD  WorkSize=Active.Work.Width*Active.Work.Height;
        UDWORD  Pos,Pos2,XPos,YPos,XPos2,YPos2,PosdY;
	UBYTE	BlueShft,GreenShft,RedShft;
	UWORD	*WorkBufferW;
	UWORD	indx;

	BlueShft=Active.BlueShift>>3;
	GreenShft=Active.GreenShift>>3;
	RedShft=Active.RedShift>>3;
	WorkBufferW=(UWORD*) WorkBuffer;

	if(Active.XRatio==65536 && Active.YRatio==65536)
	{
		Pos2=0;
	        for(Pos=0;Pos<WorkSize;Pos++)
	        {
			indx=WorkBufferW[Pos];
        	        ScreenBuffer[Pos2+BlueShft]=Palette24bppBlue[indx];
        	        ScreenBuffer[Pos2+GreenShft]=Palette24bppGreen[indx];
        	        ScreenBuffer[Pos2+RedShft]=Palette24bppRed[indx];
			Pos2+=3;
		}
	}
	else
	{
		Pos2=0;
		YPos2=0;
        	for(YPos=0;YPos<Active.Screen.Height;YPos++)
		{
			PosdY=(YPos2>>16)*Active.Work.Width;
			XPos2=0;
			WorkBufferW+=PosdY;
	        	for(XPos=0;XPos<Active.Screen.Width;XPos++)
		        {
				indx=WorkBufferW[XPos2>>16];
                                ScreenBuffer[Pos2+BlueShft]=Palette24bppBlue[WorkBufferW[indx]];
                                ScreenBuffer[Pos2+GreenShft]=Palette24bppGreen[WorkBufferW[indx]];
                                ScreenBuffer[Pos2+RedShft]=Palette24bppRed[WorkBufferW[indx]];
				Pos2+=3;
				XPos2+=Active.XRatio;
			}
			WorkBufferW-=PosdY;
			YPos2+=Active.YRatio;
		}
	}
}

static VOID    Bpp16to15(UBYTE *WorkBuffer, UBYTE *ScreenBuffer)
{
	UDWORD  WorkSize=Active.Work.Width*Active.Work.Height;
        UDWORD  Pos,XPos,YPos,XPos2,YPos2,PosdY;
	UWORD	*ScreenBufferW;
	UWORD	*WorkBufferW;

	ScreenBufferW=(UWORD*) ScreenBuffer;
	WorkBufferW=(UWORD*) WorkBuffer;

	if(Active.XRatio==65536 && Active.YRatio==65536)
	{
	        for(Pos=0;Pos<WorkSize;Pos++)
	        {
			ScreenBufferW[Pos]=Palette15bpp[WorkBufferW[Pos]];
		}
	}
	else
	{
		YPos2=0;
		Pos=0;
        	for(YPos=0;YPos<Active.Screen.Height;YPos++)
		{
			PosdY=(YPos2>>16)*Active.Work.Width;
			XPos2=0;
			WorkBufferW+=PosdY;
	        	for(XPos=0;XPos<Active.Screen.Width;XPos++)
		        {
				ScreenBufferW[Pos]=Palette15bpp[WorkBufferW[XPos2>>16]];
				++Pos;
				XPos2+=Active.XRatio;
			}
			WorkBufferW-=PosdY;
			YPos2+=Active.YRatio;
		}
	}
}

static VOID    Bpp16to8(UBYTE *WorkBuffer, UBYTE *ScreenBuffer)
{
	UDWORD  WorkSize=Active.Work.Width*Active.Work.Height;
        UDWORD  Pos,XPos,YPos,XPos2,YPos2,PosdY;
	UWORD	*WorkBufferW;

	WorkBufferW=(UWORD*)WorkBuffer;

	if(Active.XRatio==65536 && Active.YRatio==65536)
	{
	        for(Pos=0;Pos<WorkSize;Pos++)
	        {
			ScreenBuffer[Pos]=Palette8bpp[WorkBufferW[Pos]];
		}
	}
	else
	{
		YPos2=0;
		Pos=0;
        	for(YPos=0;YPos<Active.Screen.Height;YPos++)
		{
			PosdY=(YPos2>>16)*Active.Work.Width;
			XPos2=0;
			WorkBufferW+=PosdY;
	        	for(XPos=0;XPos<Active.Screen.Width;XPos++)
		        {
				ScreenBuffer[Pos]=Palette8bpp[WorkBufferW[XPos2>>16]];
				++Pos;
				XPos2+=Active.XRatio;
			}
			WorkBufferW-=PosdY;
			YPos2+=Active.YRatio;
		}
	}
}

static VOID    Bpp16toFake(UBYTE *WorkBuffer, UBYTE *ScreenBuffer)
{
        UDWORD  Pos,Pos2,XPos,XPos2,YPos,YPos2,PosdY;
	UWORD	x,y;
	UWORD	*WorkBufferW;
	UBYTE	*ScreenBuff2;
	UWORD	Col16;

	WorkBufferW=(UWORD*)WorkBuffer;
	ScreenBuff2=ScreenBuffer+Active.Screen.Width;
	Pos=0;
	Pos2=0;

	if(FakeMode==m320x400 || FakeMode==m320x480)
	{
		if(Active.XRatio==65536 && Active.YRatio==65536)
		{
		        for(y=0;y<Active.Work.Height;y++)
			{
			        for(x=0;x<Active.Work.Width;x++)
        			{
					Col16=WorkBufferW[Pos2];
					ScreenBuffer[Pos]=PaletteFakeRedBlue[Col16];
					ScreenBuff2[Pos]=PaletteFakeGreen[Col16];
					++Pos;
					++Pos2;
				}
				Pos+=Active.Work.Width;
			}
		}
		else
		{
			YPos2=0;
			Pos=0;
	        	for(YPos=0;YPos<Active.Screen.Height/2;YPos++)
			{
				PosdY=(YPos2>>16)*Active.Work.Width;
				WorkBufferW+=PosdY;
				XPos2=0;
		        	for(XPos=0;XPos<Active.Screen.Width;XPos++)
			        {
					Col16=WorkBufferW[XPos2>>16];
					ScreenBuffer[Pos]=PaletteFakeRedBlue[Col16];
					ScreenBuff2[Pos]=PaletteFakeGreen[Col16];
					++Pos;
					XPos2+=Active.XRatio;
				}
				WorkBufferW-=PosdY;
				Pos+=Active.Screen.Width;
				YPos2+=Active.YRatio;
			}
		}
	}
	else if(FakeMode==m640x400 || FakeMode==m640x480)
	{
		if(Active.XRatio==65536 && Active.YRatio==65536)
		{
		        for(y=0;y<Active.Work.Height;y++)
			{
			        for(x=0;x<Active.Work.Width;x++)
	        		{
					Col16=WorkBufferW[Pos2];
					ScreenBuffer[Pos]=PaletteFakeRedBlue[Col16];
					ScreenBuffer[Pos+1]=PaletteFakeGreen[Col16];
					Pos+=2;
					++Pos2;
				}
			}
		}
		else
		{
			YPos2=0;
			Pos=0;
	        	for(YPos=0;YPos<Active.Screen.Height;YPos++)
			{
				PosdY=(YPos2>>16)*Active.Work.Width;
				XPos2=0;
				WorkBufferW+=PosdY;
		        	for(XPos=0;XPos<Active.Screen.Width/2;XPos++)
			        {
					Col16=WorkBufferW[XPos2>>16];
					ScreenBuffer[Pos]=PaletteFakeRedBlue[Col16];
					ScreenBuffer[Pos+1]=PaletteFakeGreen[Col16];
					Pos+=2;
					XPos2+=Active.XRatio;
				}
				WorkBufferW-=PosdY;
				YPos2+=Active.YRatio;
			}
		}
	}
}

static VOID    Bpp15to32(UBYTE *WorkBuffer, UBYTE *ScreenBuffer)
{
	UDWORD  WorkSize=Active.Work.Width*Active.Work.Height;
        UDWORD  Pos,Pos2,XPos,YPos,XPos2,YPos2,PosdY;
	UBYTE	BlueShft,GreenShft,RedShft;
	UWORD	*WorkBufferW;
	UWORD	indx;

	BlueShft=Active.BlueShift>>3;
	GreenShft=Active.GreenShift>>3;
	RedShft=Active.RedShift>>3;

	WorkBufferW=(UWORD*) WorkBuffer;

	if(Active.XRatio==65536 && Active.YRatio==65536)
	{
		Pos2=0;
	        for(Pos=0;Pos<WorkSize;Pos++)
	        {
			indx=WorkBufferW[Pos];
        	        ScreenBuffer[Pos2+BlueShft]=Palette32bppBlue[indx];
        	        ScreenBuffer[Pos2+GreenShft]=Palette32bppGreen[indx];
        	        ScreenBuffer[Pos2+RedShft]=Palette32bppRed[indx];
			Pos2+=4;
		}
	}
	else
	{
		Pos2=0;
		YPos2=0;
        	for(YPos=0;YPos<Active.Screen.Height;YPos++)
		{
			PosdY=(YPos2>>16)*Active.Work.Width;
			XPos2=0;
			WorkBufferW+=PosdY;
	        	for(XPos=0;XPos<Active.Screen.Width;XPos++)
		        {
				indx=WorkBufferW[XPos2>>16];
		       	        ScreenBuffer[Pos2+BlueShft]=Palette32bppBlue[indx];
        		        ScreenBuffer[Pos2+GreenShft]=Palette32bppGreen[indx];
        	        	ScreenBuffer[Pos2+RedShft]=Palette32bppRed[indx];
				Pos2+=4;
				XPos2+=Active.XRatio;
			}
			WorkBufferW-=PosdY;
			YPos2+=Active.YRatio;
		}
	}
}

static VOID    Bpp15to24(UBYTE *WorkBuffer, UBYTE *ScreenBuffer)
{
	UDWORD  WorkSize=Active.Work.Width*Active.Work.Height;
        UDWORD  Pos,Pos2,XPos,YPos,XPos2,YPos2,PosdY;
	UBYTE	BlueShft,GreenShft,RedShft;
	UWORD	*WorkBufferW;
	UWORD	indx;

	BlueShft=Active.BlueShift>>3;
	GreenShft=Active.GreenShift>>3;
	RedShft=Active.RedShift>>3;
	WorkBufferW=(UWORD*) WorkBuffer;

	if(Active.XRatio==65536 && Active.YRatio==65536)
	{
		Pos2=0;
	        for(Pos=0;Pos<WorkSize;Pos++)
	        {
			indx=WorkBufferW[Pos];
        	        ScreenBuffer[Pos2+BlueShft]=Palette24bppBlue[indx];
        	        ScreenBuffer[Pos2+GreenShft]=Palette24bppGreen[indx];
        	        ScreenBuffer[Pos2+RedShft]=Palette24bppRed[indx];
			Pos2+=3;
		}
	}
	else
	{
		Pos2=0;
		YPos2=0;
        	for(YPos=0;YPos<Active.Screen.Height;YPos++)
		{
			PosdY=(YPos2>>16)*Active.Work.Width;
			XPos2=0;
			WorkBufferW+=PosdY;
	        	for(XPos=0;XPos<Active.Screen.Width;XPos++)
		        {
				indx=WorkBufferW[XPos2>>16];
                                ScreenBuffer[Pos2+BlueShft]=Palette24bppBlue[WorkBufferW[indx]];
                                ScreenBuffer[Pos2+GreenShft]=Palette24bppGreen[WorkBufferW[indx]];
                                ScreenBuffer[Pos2+RedShft]=Palette24bppRed[WorkBufferW[indx]];
				Pos2+=3;
				XPos2+=Active.XRatio;
			}
			WorkBufferW-=PosdY;
			YPos2+=Active.YRatio;
		}
	}
}

static VOID    Bpp15to16(UBYTE *WorkBuffer, UBYTE *ScreenBuffer)
{
	UDWORD  WorkSize=Active.Work.Width*Active.Work.Height;
        UDWORD  Pos,XPos,YPos,XPos2,YPos2,PosdY;
	UWORD	*WorkBufferW;
	UWORD	*ScreenBufferW;

	ScreenBufferW=(UWORD*)ScreenBuffer;
	WorkBufferW=(UWORD*) WorkBuffer;

	if(Active.XRatio==65536 && Active.YRatio==65536)
	{
	        for(Pos=0;Pos<WorkSize;Pos++)
	        {
        	        ScreenBufferW[Pos]=Palette16bpp[WorkBufferW[Pos]];
		}
	}
	else
	{
		YPos2=0;
		Pos=0;
        	for(YPos=0;YPos<Active.Screen.Height;YPos++)
		{
			PosdY=(YPos2>>16)*Active.Work.Width;
			XPos2=0;
			WorkBufferW+=PosdY;
	        	for(XPos=0;XPos<Active.Screen.Width;XPos++)
		        {
	        	        ScreenBufferW[Pos]=Palette16bpp[WorkBufferW[XPos2>>16]];
				XPos2+=Active.XRatio;
				Pos++;
			}
			WorkBufferW-=PosdY;
			YPos2+=Active.YRatio;
		}
	}
}

static VOID    Bpp15to8(UBYTE *WorkBuffer, UBYTE *ScreenBuffer)
{
	UDWORD  WorkSize=Active.Work.Width*Active.Work.Height;
        UDWORD  Pos,XPos,YPos,XPos2,YPos2,PosdY;
	UWORD	*WorkBufferW;

	WorkBufferW=(UWORD*)WorkBuffer;

	if(Active.XRatio==65536 && Active.YRatio==65536)
	{
	        for(Pos=0;Pos<WorkSize;Pos++)
        	{
			ScreenBuffer[Pos]=Palette8bpp[WorkBufferW[Pos]];
		}
	}
	else
	{
		YPos2=0;
		Pos=0;
        	for(YPos=0;YPos<Active.Screen.Height;YPos++)
		{
			PosdY=(YPos2>>16)*Active.Work.Width;
			XPos2=0;
			WorkBufferW+=PosdY;
	        	for(XPos=0;XPos<Active.Screen.Width;XPos++)
		        {
				ScreenBuffer[Pos]=Palette8bpp[WorkBufferW[XPos2>>16]];
				++Pos;
				XPos2+=Active.XRatio;
			}
			WorkBufferW-=PosdY;
			YPos2+=Active.YRatio;
		}
	}
}

static VOID    Bpp15toFake(UBYTE *WorkBuffer, UBYTE *ScreenBuffer)
{
        UDWORD  Pos,Pos2,XPos,XPos2,YPos,YPos2,PosdY;
	UWORD	x,y;
	UWORD	*WorkBufferW;
	UBYTE	*ScreenBuff2;
        UWORD   Col15;

	WorkBufferW=(UWORD*)WorkBuffer;
	ScreenBuff2=ScreenBuffer+Active.Screen.Width;
	Pos=0;
	Pos2=0;

	if(FakeMode==m320x400 || FakeMode==m320x480)
	{
		if(Active.XRatio==65536 && Active.YRatio==65536)
		{
		        for(y=0;y<Active.Work.Height;y++)
			{
			        for(x=0;x<Active.Work.Width;x++)
        			{
                                        Col15=WorkBufferW[Pos2];
                                        ScreenBuffer[Pos]=PaletteFakeRedBlue[Col15];
                                        ScreenBuff2[Pos]=PaletteFakeGreen[Col15];
					++Pos;
					++Pos2;
				}
				Pos+=Active.Work.Width;
			}
		}
		else
		{
			YPos2=0;
			Pos=0;
	        	for(YPos=0;YPos<Active.Screen.Height/2;YPos++)
			{
				PosdY=(YPos2>>16)*Active.Work.Width;
				WorkBufferW+=PosdY;
				XPos2=0;
		        	for(XPos=0;XPos<Active.Screen.Width;XPos++)
			        {
                                        Col15=WorkBufferW[XPos2>>16];
                                        ScreenBuffer[Pos]=PaletteFakeRedBlue[Col15];
                                        ScreenBuff2[Pos]=PaletteFakeGreen[Col15];
					++Pos;
					XPos2+=Active.XRatio;
				}
				WorkBufferW-=PosdY;
				Pos+=Active.Screen.Width;
				YPos2+=Active.YRatio;
			}
		}
	}
	else if(FakeMode==m640x400 || FakeMode==m640x480)
	{
		if(Active.XRatio==65536 && Active.YRatio==65536)
		{
		        for(y=0;y<Active.Work.Height;y++)
			{
			        for(x=0;x<Active.Work.Width;x++)
	        		{
                                        Col15=WorkBufferW[Pos2];
                                        ScreenBuffer[Pos]=PaletteFakeRedBlue[Col15];
                                        ScreenBuffer[Pos+1]=PaletteFakeGreen[Col15];
					Pos+=2;
					++Pos2;
				}
			}
		}
		else
		{
			YPos2=0;
			Pos=0;
	        	for(YPos=0;YPos<Active.Screen.Height;YPos++)
			{
				PosdY=(YPos2>>16)*Active.Work.Width;
				XPos2=0;
				WorkBufferW+=PosdY;
		        	for(XPos=0;XPos<Active.Screen.Width/2;XPos++)
			        {
                                        Col15=WorkBufferW[XPos2>>16];
                                        ScreenBuffer[Pos]=PaletteFakeRedBlue[Col15];
                                        ScreenBuffer[Pos+1]=PaletteFakeGreen[Col15];
					Pos+=2;
					XPos2+=Active.XRatio;
				}
				WorkBufferW-=PosdY;
				YPos2+=Active.YRatio;
			}
		}
	}
}

static VOID    Bpp8to32(UBYTE *WorkBuffer, UBYTE *ScreenBuffer)
{
        UDWORD  WorkSize=Active.Work.Width*Active.Work.Height;
        UBYTE   Col;
	UBYTE	BlueShft,GreenShft,RedShft;
        UDWORD  Pos,XPos,YPos,XPos2,YPos2,PosdY,Pos2;

	BlueShft=Active.BlueShift>>3;
	GreenShft=Active.GreenShift>>3;
	RedShft=Active.RedShift>>3;

	if(Active.XRatio==65536 && Active.YRatio==65536)
	{
		Pos2=0;
	        for(Pos=0;Pos<WorkSize;Pos++)
        	{
	                Col=WorkBuffer[Pos];
        	        ScreenBuffer[Pos2+BlueShft]=Palette32bpp[Col*3+2];
                	ScreenBuffer[Pos2+GreenShft]=Palette32bpp[Col*3+1];
	                ScreenBuffer[Pos2+RedShft]=Palette32bpp[Col*3];
			Pos2+=4;
		}
        }
	else
	{
		YPos2=0;
		Pos=0;
	        for(YPos=0;YPos<Active.Screen.Height;YPos++)
		{
			PosdY=(YPos2>>16)*Active.Work.Width;
			XPos2=0;
			WorkBuffer+=PosdY;
		        for(XPos=0;XPos<Active.Screen.Width;XPos++)
		        {
	        	        Col=WorkBuffer[XPos2>>16];
        		        ScreenBuffer[Pos+BlueShft]=Palette32bpp[Col*3+2];
	                	ScreenBuffer[Pos+GreenShft]=Palette32bpp[Col*3+1];
	        	        ScreenBuffer[Pos+RedShft]=Palette32bpp[Col*3];
				Pos+=4;
				XPos2+=Active.XRatio;
			}
			WorkBuffer-=PosdY;
			YPos2+=Active.YRatio;
		}
	}
}

static VOID    Bpp8to24(UBYTE *WorkBuffer, UBYTE *ScreenBuffer)
{
        UDWORD  WorkSize=Active.Work.Width*Active.Work.Height;
        UBYTE   Col;
	UBYTE	BlueShft,GreenShft,RedShft;
        UDWORD  Pos,XPos,YPos,XPos2,YPos2,PosdY,Pos2;

	BlueShft=Active.BlueShift>>3;
	GreenShft=Active.GreenShift>>3;
	RedShft=Active.RedShift>>3;

	if(Active.XRatio==65536 && Active.YRatio==65536)
	{

		Pos2=0;
	        for(Pos=0;Pos<WorkSize;Pos++)
        	{
	                Col=WorkBuffer[Pos];
        	        ScreenBuffer[Pos2+BlueShft]=Palette24bpp[Col*3+2];
                	ScreenBuffer[Pos2+GreenShft]=Palette24bpp[Col*3+1];
	                ScreenBuffer[Pos2+RedShft]=Palette24bpp[Col*3];
			Pos2+=3;
		}
        }
	else
	{
		YPos2=0;
		Pos=0;
	        for(YPos=0;YPos<Active.Screen.Height;YPos++)
		{
			PosdY=(YPos2>>16)*Active.Work.Width;
			XPos2=0;
			WorkBuffer+=PosdY;
		        for(XPos=0;XPos<Active.Screen.Width;XPos++)
		        {
	        	        Col=WorkBuffer[XPos2>>16];
	        	        ScreenBuffer[Pos+BlueShft]=Palette24bpp[Col*3+2];
        	        	ScreenBuffer[Pos+GreenShft]=Palette24bpp[Col*3+1];
	        	        ScreenBuffer[Pos+RedShft]=Palette24bpp[Col*3];
				Pos+=3;
				XPos2+=Active.XRatio;
			}
			WorkBuffer-=PosdY;
			YPos2+=Active.YRatio;
		}
	}
}


static VOID    Bpp8to16(UBYTE *WorkBuffer, UBYTE *ScreenBuffer)
{
        UDWORD  WorkSize=Active.Work.Width*Active.Work.Height;
        UDWORD  Pos,XPos,YPos,XPos2,YPos2,PosdY;
	UWORD	*ScreenBufferW;

	ScreenBufferW=(UWORD*) ScreenBuffer;

	if(Active.XRatio==65536 && Active.YRatio==65536)
	{
	        for(Pos=0;Pos<WorkSize;Pos++)
        	{
        	        ScreenBufferW[Pos]=Palette16bpp[WorkBuffer[Pos]];
		}
        }
	else
	{
		YPos2=0;
		Pos=0;
	        for(YPos=0;YPos<Active.Screen.Height;YPos++)
		{
			PosdY=(YPos2>>16)*Active.Work.Width;
			XPos2=0;
			WorkBuffer+=PosdY;
		        for(XPos=0;XPos<Active.Screen.Width;XPos++)
		        {
	        	        ScreenBufferW[Pos]=Palette16bpp[WorkBuffer[XPos2>>16]];
				Pos++;
				XPos2+=Active.XRatio;
			}
			WorkBuffer-=PosdY;
			YPos2+=Active.YRatio;
		}
	}
}

static VOID     Bpp8to15(UBYTE *WorkBuffer, UBYTE *ScreenBuffer)
{
        UDWORD  WorkSize=Active.Work.Width*Active.Work.Height;
        UDWORD  Pos,XPos,YPos,XPos2,YPos2,PosdY;
	UWORD	*ScreenBufferW;

	ScreenBufferW=(UWORD*) ScreenBuffer;

	if(Active.XRatio==65536 && Active.YRatio==65536)
	{
	        for(Pos=0;Pos<WorkSize;Pos++)
        	{
        	        ScreenBufferW[Pos]=Palette15bpp[WorkBuffer[Pos]];
		}
        }
	else
	{
		YPos2=0;
		Pos=0;
	        for(YPos=0;YPos<Active.Screen.Height;YPos++)
		{
			PosdY=(YPos2>>16)*Active.Work.Width;
			XPos2=0;
			WorkBuffer+=PosdY;
		        for(XPos=0;XPos<Active.Screen.Width;XPos++)
		        {
	        	        ScreenBufferW[Pos]=Palette15bpp[WorkBuffer[XPos2>>16]];
				Pos++;
				XPos2+=Active.XRatio;
			}
			WorkBuffer-=PosdY;
			YPos2+=Active.YRatio;
		}
	}
}

/******************************************************************************/
/*									      */
/*	  	    S C A L E    T R A N S F O R M A T I O N S		      */
/*									      */
/******************************************************************************/
static VOID    Scale24(UBYTE *WorkBuffer, UBYTE *ScreenBuffer)
{
        UDWORD  Pos,XPos,YPos,XPos2,YPos2,PosdX,PosdY;
	UBYTE	BlueShft,GreenShft,RedShft;

	BlueShft=Active.BlueShift>>3;
	GreenShft=Active.GreenShift>>3;
	RedShft=Active.RedShift>>3;

	YPos2=0;
	Pos=0;
        for(YPos=0;YPos<Active.Screen.Height;YPos++)
	{
		PosdY=(YPos2>>16)*Active.Work.Width*3;
		XPos2=0;
		WorkBuffer+=PosdY;
	        for(XPos=0;XPos<Active.Screen.Width;XPos++)
	        {
			PosdX=(XPos2>>16)*3;
        	        ScreenBuffer[Pos+BlueShft]=WorkBuffer[PosdX];   //Blue
        	        ScreenBuffer[Pos+GreenShft]=WorkBuffer[PosdX+1];//Green
        	        ScreenBuffer[Pos+RedShft]=WorkBuffer[PosdX+2];  //Red
			Pos+=3;
			XPos2+=Active.XRatio;
		}
		WorkBuffer-=PosdY;
		YPos2+=Active.YRatio;
	}
}

static VOID    Scale16(UBYTE *WorkBuffer, UBYTE *ScreenBuffer)
{
        UDWORD  Pos,XPos,YPos,XPos2,YPos2,PosdY;
	UWORD	*WorkBufferW;
	UWORD	*ScreenBufferW;

	WorkBufferW=(UWORD*)WorkBuffer;
	ScreenBufferW=(UWORD*)ScreenBuffer;

	YPos2=0;
	Pos=0;
        for(YPos=0;YPos<Active.Screen.Height;YPos++)
	{
		PosdY=(YPos2>>16)*Active.Work.Width;
		XPos2=0;
		WorkBufferW+=PosdY;
	        for(XPos=0;XPos<Active.Screen.Width;XPos++)
	        {
        	        ScreenBufferW[Pos]=WorkBufferW[XPos2>>16];
			Pos++;
			XPos2+=Active.XRatio;
		}
		WorkBufferW-=PosdY;
		YPos2+=Active.YRatio;
	}
}

static VOID    Scale15(UBYTE *WorkBuffer, UBYTE *ScreenBuffer)
{
        UDWORD  Pos,XPos,YPos,XPos2,YPos2,PosdY;
	UWORD	*WorkBufferW;
	UWORD	*ScreenBufferW;

	WorkBufferW=(UWORD*)WorkBuffer;
	ScreenBufferW=(UWORD*)ScreenBuffer;

	YPos2=0;
	Pos=0;
        for(YPos=0;YPos<Active.Screen.Height;YPos++)
	{
		PosdY=(YPos2>>16)*Active.Work.Width;
		XPos2=0;
		WorkBufferW+=PosdY;
	        for(XPos=0;XPos<Active.Screen.Width;XPos++)
	        {
        	        ScreenBufferW[Pos]=WorkBufferW[XPos2>>16];
			Pos++;
			XPos2+=Active.XRatio;
		}
		WorkBufferW-=PosdY;
		YPos2+=Active.YRatio;
	}
}

static VOID    Scale8(UBYTE *WorkBuffer, UBYTE *ScreenBuffer)
{
        UDWORD  Pos,XPos,YPos,XPos2,YPos2,PosdY;

	YPos2=0;
	Pos=0;
        for(YPos=0;YPos<Active.Screen.Height;YPos++)
	{
		PosdY=(YPos2>>16)*Active.Work.Width;
		XPos2=0;
		WorkBuffer+=PosdY;
	        for(XPos=0;XPos<Active.Screen.Width;XPos++)
	        {
        	        ScreenBuffer[Pos]=WorkBuffer[XPos2>>16];
			Pos++;
			XPos2+=Active.XRatio;
		}
		WorkBuffer-=PosdY;
		YPos2+=Active.YRatio;
	}
}

/******************************************************************************/
/*									      */
/*	 	      P A L E T T E    C A L C U L A T I O N S		      */
/*									      */
/******************************************************************************/

static VOID    Calc24to16bppPal(UWORD *Pal24to16) 
{
	UWORD Green,Red;
	for(Red=0;Red<256;++Red)
		for(Green=0;Green<256;++Green)
		{
			Pal24to16[Green+Red*256]=((Green>>2)<<5)+((Red>>3)<<11);
		}
}

static VOID    Calc24to15bppPal(UWORD *Pal24to15)
{
	UWORD Red,Green;

	for(Red=0;Red<256;++Red)
		for(Green=0;Green<256;++Green)
		{
			Pal24to15[Green+Red*256]=((Green>>3)<<5)+((Red>>3)<<10);
		}
}

static VOID    Calc24to8bppPal(UBYTE *Pal24to8)
{
	UBYTE Red,Green,Blue;

	outp(0x3c8,0);
	for(Blue=0;Blue<6;++Blue)
		for(Green=0;Green<7;++Green)
			for(Red=0;Red<6;++Red)
			{
				outp(0x3c9,Red*12+3);
				outp(0x3c9,Green*10+3);
				outp(0x3c9,Blue*12+3);
			}
	for(Blue=0;Blue<64;++Blue)
		for(Green=0;Green<64;++Green)
			for(Red=0;Red<64;++Red)
			{
                                Pal24to8[Red+Green*64+Blue*(64*64)]=Red/12+(Green/10)*6+(Blue/12)*(6*7);
			}
	
}

static VOID    Calc24toFakePal(UBYTE *Pal24toFake)
{
	UWORD Red,Green,Blue;

	outp(0x3c8,0);
	for(Green=0;Green<64;++Green)
	{
		outp(0x3c9,0);
		outp(0x3c9,Green);
		outp(0x3c9,0);

	}
	for(Blue=0;Blue<13;++Blue)
		for(Red=0;Red<13;++Red)
		{
			outp(0x3c9,Red*5+3);
			outp(0x3c9,0);
			outp(0x3c9,Blue*5+3);
		}
	for(Blue=0;Blue<256;++Blue)
		for(Red=0;Red<256;++Red)
		{
			Pal24toFake[Red+Blue*256]=64+Red/21+(Blue/21)*13;
		}

}


static VOID    Calc16to32bppPal(UBYTE *Pal16to32Red, UBYTE *Pal16to32Green, UBYTE *Pal16to32Blue)
{
	UBYTE Red,Green,Blue;

	for(Red=0;Red<32;++Red)
		for(Green=0;Green<64;++Green)
			for(Blue=0;Blue<32;++Blue)
			{
                                Pal16to32Blue[Blue+Green*32+Red*(32*64)]=Blue*8;
                                Pal16to32Green[Blue+Green*32+Red*(32*64)]=Green*4;
                                Pal16to32Red[Blue+Green*32+Red*(32*64)]=Red*8;
			}
}

static VOID    Calc16to24bppPal(UBYTE *Pal16to24Red, UBYTE *Pal16to24Green, UBYTE *Pal16to24Blue)
{
	UBYTE Red,Green,Blue;

	for(Red=0;Red<32;++Red)
		for(Green=0;Green<64;++Green)
			for(Blue=0;Blue<32;++Blue)
			{
                                Pal16to24Blue[Blue+Green*32+Red*(32*64)]=Blue*8;
                                Pal16to24Green[Blue+Green*32+Red*(32*64)]=Green*4;
                                Pal16to24Red[Blue+Green*32+Red*(32*64)]=Red*8;

			}
}


static VOID    Calc16to15bppPal(UWORD *Pal16to15)
{
	UBYTE Red,Green,Blue;

	for(Red=0;Red<32;++Red)
		for(Green=0;Green<64;++Green)
			for(Blue=0;Blue<32;++Blue)
			{
                                Pal16to15[Blue+Green*32+Red*(32*64)]=(Blue+((Green>>1)<<5)+(Red<<10))&0x7fff;
			}
}

static VOID    Calc16to8bppPal(UBYTE *Pal16to8)
{
	UBYTE Red,Green,Blue;

	outp(0x3c8,0);
	for(Blue=0;Blue<6;++Blue)
		for(Green=0;Green<7;++Green)
			for(Red=0;Red<6;++Red)
			{
				outp(0x3c9,Red*12+3);
				outp(0x3c9,Green*10+3);
				outp(0x3c9,Blue*12+3);
			}

	for(Red=0;Red<32;++Red)
		for(Green=0;Green<64;++Green)
			for(Blue=0;Blue<32;++Blue)
			{
                                Pal16to8[Blue+Green*32+Red*(32*64)]=Red/6+(Green/10)*6+(Blue/6)*(6*7);
			}
	
}

static VOID    Calc16toFakePal(UBYTE *Pal16toFakeRedBlue,UBYTE *Pal16toFakeGreen)
{
	UWORD Red,Green,Blue;

	outp(0x3c8,0);
	for(Green=0;Green<64;++Green)
	{
		outp(0x3c9,0);
		outp(0x3c9,Green);
		outp(0x3c9,0);

	}
	for(Blue=0;Blue<13;++Blue)
		for(Red=0;Red<13;++Red)
		{
			outp(0x3c9,Red*6+3);	//*6 to solve precision errors
			outp(0x3c9,0);		
			outp(0x3c9,Blue*6+3);	//*6 to solve precision errors
		}
	for(Blue=0;Blue<32;++Blue)
		for(Green=0;Green<64;++Green)
			for(Red=0;Red<32;++Red)
			{
				Pal16toFakeGreen[Red*32*64+Green*32+Blue]=Green;
			}

	for(Green=0;Green<64;++Green)
		for(Blue=0;Blue<32;++Blue)
			for(Red=0;Red<32;++Red)
			{
				Pal16toFakeRedBlue[Red*32*64+Green*32+Blue]=64+Red/3+(Blue/3)*13;
			}

}

static VOID    Calc15to32bppPal(UBYTE *Pal15to32Red, UBYTE *Pal15to32Green, UBYTE *Pal15to32Blue)
{
	UBYTE Red,Green,Blue;

	for(Red=0;Red<32;++Red)
                for(Green=0;Green<32;++Green)
			for(Blue=0;Blue<32;++Blue)
			{
                                Pal15to32Blue[Blue+Green*32+Red*(32*32)]=Blue*8;
                                Pal15to32Green[Blue+Green*32+Red*(32*32)]=Green*8;
                                Pal15to32Red[Blue+Green*32+Red*(32*32)]=Red*8;
			}
}

static VOID    Calc15to24bppPal(UBYTE *Pal15to24Red, UBYTE *Pal15to24Green, UBYTE *Pal15to24Blue)
{
	UBYTE Red,Green,Blue;

	for(Red=0;Red<32;++Red)
                for(Green=0;Green<32;++Green)
			for(Blue=0;Blue<32;++Blue)
			{
                                Pal15to24Blue[Blue+Green*32+Red*(32*32)]=Blue*8;
                                Pal15to24Green[Blue+Green*32+Red*(32*32)]=Green*8;
                                Pal15to24Red[Blue+Green*32+Red*(32*32)]=Red*8;
			}
}

static VOID    Calc15to16bppPal(UWORD *Pal15to16)
{
	UBYTE Red,Green,Blue;

	for(Red=0;Red<32;++Red)
                for(Green=0;Green<32;++Green)
			for(Blue=0;Blue<32;++Blue)
			{
                                Pal15to16[Blue+Green*32+Red*(32*32)]=Blue+((Green*2)<<5)+(Red<<11);
			}
}

static VOID    Calc15to8bppPal(UBYTE *Pal15to8)
{
	UBYTE Red,Green,Blue;

	outp(0x3c8,0);
	for(Blue=0;Blue<6;++Blue)
		for(Green=0;Green<7;++Green)
			for(Red=0;Red<6;++Red)
			{
				outp(0x3c9,Red*12+3);
				outp(0x3c9,Green*10+3);
				outp(0x3c9,Blue*12+3);
			}

	for(Red=0;Red<32;++Red)
		for(Green=0;Green<32;++Green)
			for(Blue=0;Blue<32;++Blue)
			{
                                Pal15to8[Blue+Green*32+Red*32*32]=Red/6+(Green/6)*6+(Blue/6)*(6*7);
			}
	
}

static VOID    Calc15toFakePal(UBYTE *Pal15toFakeRedBlue,UBYTE *Pal15toFakeGreen)
{
	UWORD Red,Green,Blue;

	outp(0x3c8,0);
	for(Green=0;Green<32;++Green)
	{
		outp(0x3c9,0);
		outp(0x3c9,Green*2+1);
		outp(0x3c9,0);

	}
	for(Blue=0;Blue<14;++Blue)
		for(Red=0;Red<14;++Red)
		{
			outp(0x3c9,Red*6);	//*6 to solve precision errors
			outp(0x3c9,0);		
			outp(0x3c9,Blue*6);	//*6 to solve precision errors
		}
	for(Blue=0;Blue<32;++Blue)
		for(Green=0;Green<32;++Green)
			for(Red=0;Red<32;++Red)
			{
				Pal15toFakeGreen[Red*32*32+Green*32+Blue]=Green;
			}

	for(Green=0;Green<32;++Green)
		for(Blue=0;Blue<32;++Blue)
			for(Red=0;Red<32;++Red)
			{
				Pal15toFakeRedBlue[Red*32*32+Green*32+Blue]=32+Red/3+(Blue/3)*14;
			}

}


static VOID    Calc8to32bppPal(UBYTE *Pal8to32)
{
	UWORD	cols;

	for(cols=0;cols<256;++cols)
	{
		Pal8to32[cols*3]=Active.Palette[cols].r*4;
		Pal8to32[cols*3+1]=Active.Palette[cols].g*4;
		Pal8to32[cols*3+2]=Active.Palette[cols].b*4;
	}
}

static VOID    Calc8to24bppPal(UBYTE *Pal8to24)
{
	UWORD	cols;

	for(cols=0;cols<256;++cols)
	{
		Pal8to24[cols*3]=Active.Palette[cols].r*4;
		Pal8to24[cols*3+1]=Active.Palette[cols].g*4;
		Pal8to24[cols*3+2]=Active.Palette[cols].b*4;
	}
}

static VOID    Calc8to16bppPal(UWORD *Pal8to16)
{
	UWORD	cols;
	UBYTE	Red,Green,Blue;

	for(cols=0;cols<256;++cols)
	{
		
		Red=(Active.Palette[cols].r)/2;
		Green=Active.Palette[cols].g;
		Blue=(Active.Palette[cols].b)/2;
		Pal8to16[cols]=Blue+(Green<<5)+(Red<<11);
	}
}

static VOID    Calc8to15bppPal(UWORD *Pal8to15)
{
	UWORD	cols;
	UBYTE	Red,Green,Blue;

	for(cols=0;cols<256;++cols)
	{
		Red=(Active.Palette[cols].r)/2;
		Green=(Active.Palette[cols].g)/2;
		Blue=(Active.Palette[cols].b)/2;

		Pal8to15[cols]=Blue+(Green<<5)+(Red<<10);
	}
}

/******************************************************************************/
/*									      */
/*	 	     	    I N I T I A L I Z A T I O N S	              */
/*									      */
/******************************************************************************/
static VOID    Init24to16()
{
	Palette16bpp=(UWORD* ) malloc(256*256*2);

	if(Palette16bpp==NULL)
	{
		Error_Code=1;
		ErrorMsg();
	}
	else
	{
		Calc24to16bppPal(Palette16bpp);
	}

}


static VOID    Init24to15()
{
	Palette15bpp=(UWORD* ) malloc(256*256*2);

	if(Palette15bpp==NULL)
	{
		Error_Code=1;
		ErrorMsg();
	}
	else
	{
		Calc24to15bppPal(Palette15bpp);
	}
}

static VOID    Init24to8()
{
	Palette8bpp=(UBYTE* ) malloc(64*64*64);
	
	if(Palette8bpp==NULL)
	{
		Error_Code=1;
		ErrorMsg();
	}
	else
	{
		Calc24to8bppPal(Palette8bpp);
	}

}

static VOID    Init24toFake()
{
	PaletteFake=(UBYTE* ) malloc(256*256);

	if(PaletteFake==NULL)
	{
		Error_Code=1;
		ErrorMsg();
	}
	else
	{
                if(Active.Screen.Width==320 && Active.Screen.Height==400)
		{
			Set320x400();
			FakeMode=m320x400;
		}

                if(Active.Screen.Width==320 && Active.Screen.Height==480)
		{
			Set320x480();
			FakeMode=m320x480;
		}

                if(Active.Screen.Width==640 && Active.Screen.Height==400)
		{
			Set640x400();
			FakeMode=m640x400;
		}

                if(Active.Screen.Width==640 && Active.Screen.Height==480)
		{
			Set640x480();
			FakeMode=m640x480;
		}

		if(Active.Screen.ResolSize!=0) Calc24toFakePal(PaletteFake);
	}
}


static VOID    Init16to32()
{	
	Palette32bppRed=(UBYTE* ) malloc(32*32*64);
	Palette32bppGreen=(UBYTE* ) malloc(32*32*64);
	Palette32bppBlue=(UBYTE* ) malloc(32*32*64);

	if(Palette32bppRed==NULL || Palette32bppGreen==NULL || Palette32bppBlue==NULL)
	{
		Error_Code=1;
		ErrorMsg();
	}
	else
	{
		Calc16to32bppPal(Palette32bppRed,Palette32bppGreen,Palette32bppBlue);
	}
}

static VOID    Init16to24()
{	
	Palette24bppRed=(UBYTE* ) malloc(32*32*64);
	Palette24bppGreen=(UBYTE* ) malloc(32*32*64);
	Palette24bppBlue=(UBYTE* ) malloc(32*32*64);

	if(Palette24bppRed==NULL || Palette24bppGreen==NULL || Palette24bppBlue==NULL)
	{
		Error_Code=1;
		ErrorMsg();
	}
	else
	{
		Calc16to24bppPal(Palette24bppRed,Palette24bppGreen,Palette24bppBlue);
	}
}

static VOID    Init16to15()
{
	Palette15bpp=(UWORD* ) malloc(32*32*64*2);

	if(Palette15bpp==NULL)
	{
		Error_Code=1;
		ErrorMsg();
	}
	else
	{
		Calc16to15bppPal(Palette15bpp);
	}
}

static VOID    Init16to8()
{
	Palette8bpp=(UBYTE* ) malloc(32*64*32);
	
	if(Palette8bpp==NULL)
	{
		Error_Code=1;
		ErrorMsg();
	}
	else
	{
		Calc16to8bppPal(Palette8bpp);
	}

}

static VOID    Init16toFake()
{
	PaletteFakeGreen=(UBYTE* ) malloc(32*64*32);
	PaletteFakeRedBlue=(UBYTE* ) malloc(32*64*32);

	if(PaletteFakeGreen==NULL || PaletteFakeRedBlue==NULL)
	{
		Error_Code=1;
		ErrorMsg();
	}
	else
	{
                if(Active.Screen.Width==320 && Active.Screen.Height==400)
		{
			Set320x400();
			FakeMode=m320x400;
		}

                if(Active.Screen.Width==320 && Active.Screen.Height==480)
		{
			Set320x480();
			FakeMode=m320x480;
		}

                if(Active.Screen.Width==640 && Active.Screen.Height==400)
		{
			Set640x400();
			FakeMode=m640x400;
		}

                if(Active.Screen.Width==640 && Active.Screen.Height==480)
		{
			Set640x480();
			FakeMode=m640x480;
		}

		if(Active.Screen.ResolSize!=0) Calc16toFakePal(PaletteFakeRedBlue,PaletteFakeGreen);
	}
}

static VOID    Init15to32()
{	
        Palette32bppRed=(UBYTE* ) malloc(32*32*32);
        Palette32bppGreen=(UBYTE* ) malloc(32*32*32);
        Palette32bppBlue=(UBYTE* ) malloc(32*32*32);

	if(Palette32bppRed==NULL || Palette32bppGreen==NULL || Palette32bppBlue==NULL)
	{
		Error_Code=1;
		ErrorMsg();
	}
	else
	{
                Calc15to32bppPal(Palette32bppRed,Palette32bppGreen,Palette32bppBlue);
	}
}

static VOID    Init15to24()
{	
        Palette24bppRed=(UBYTE* ) malloc(32*32*32);
        Palette24bppGreen=(UBYTE* ) malloc(32*32*32);
        Palette24bppBlue=(UBYTE* ) malloc(32*32*32);

	if(Palette24bppRed==NULL || Palette24bppGreen==NULL || Palette24bppBlue==NULL)
	{
		Error_Code=1;
		ErrorMsg();
	}
	else
	{
                Calc15to24bppPal(Palette24bppRed,Palette24bppGreen,Palette24bppBlue);
	}
}

static VOID    Init15to16()
{
	Palette16bpp=(UWORD*) malloc(32*32*32*2);

	if(Palette16bpp==NULL)
	{
		Error_Code=1;
		ErrorMsg();
	}
	else
	{
		Calc15to16bppPal(Palette16bpp);
	}
}

static VOID    Init15to8()
{
	Palette8bpp=(UBYTE* ) malloc(32*32*32);
	
	if(Palette8bpp==NULL)
	{
		Error_Code=1;
		ErrorMsg();
	}
	else
	{
		Calc15to8bppPal(Palette8bpp);
	}
}

static VOID    Init15toFake()
{
	PaletteFakeGreen=(UBYTE* ) malloc(32*32*32);
	PaletteFakeRedBlue=(UBYTE* ) malloc(32*32*32);

	if(PaletteFakeGreen==NULL || PaletteFakeRedBlue==NULL)
	{
		Error_Code=1;
		ErrorMsg();
	}
	else
	{
                if(Active.Screen.Width==320 && Active.Screen.Height==400)
		{
			Set320x400();
			FakeMode=m320x400;
		}

                if(Active.Screen.Width==320 && Active.Screen.Height==480)
		{
			Set320x480();
			FakeMode=m320x480;
		}

                if(Active.Screen.Width==640 && Active.Screen.Height==400)
		{
			Set640x400();
			FakeMode=m640x400;
		}

                if(Active.Screen.Width==640 && Active.Screen.Height==480)
		{
			Set640x480();
			FakeMode=m640x480;
		}
		if(Active.Screen.ResolSize!=0) Calc15toFakePal(PaletteFakeRedBlue,PaletteFakeGreen);
	}
}

static VOID    Init8to32()
{
	Palette32bpp=(UBYTE* ) malloc(256*3);
	
	if(Palette32bpp==NULL)
	{
		Error_Code=1;
		ErrorMsg();
	}
	else
	{
		Calc8to32bppPal(Palette32bpp);
	}

}

static VOID    Init8to24()
{
	Palette24bpp=(UBYTE* ) malloc(256*3);
	
	if(Palette24bpp==NULL)
	{
		Error_Code=1;
		ErrorMsg();
	}
	else
	{
		Calc8to24bppPal(Palette24bpp);
	}
}

static VOID    Init8to16()
{
	Palette16bpp=(UWORD* ) malloc(256*2);
	
	if(Palette16bpp==NULL)
	{
		Error_Code=1;
		ErrorMsg();
	}
	else
	{
		Calc8to16bppPal(Palette16bpp);
	}
}

static VOID    Init8to15()
{
	Palette15bpp=(UWORD* ) malloc(256*2);
	
	if(Palette15bpp==NULL)
	{
		Error_Code=1;
		ErrorMsg();
	}
	else
	{
		Calc8to15bppPal(Palette15bpp);
	}
}

static VOID    End24to32()
{
	free(ScreenBuffer);
}

static VOID    End24to24()
{
	free(ScreenBuffer);
}

static VOID    End24to16()
{
	free(ScreenBuffer);
	free(Palette16bpp);
}

static VOID    End24to15()
{
	free(ScreenBuffer);
	free(Palette15bpp);
}

static VOID    End24to8()
{
	free(ScreenBuffer);
	free(Palette8bpp);
}

static VOID    End24toFake()
{
	free(ScreenBuffer);
	free(PaletteFake);
}

static VOID    End16to32()
{
        free(ScreenBuffer);
        free(Palette32bppRed);
        free(Palette32bppGreen);
        free(Palette32bppBlue);
}

static VOID    End16to24()
{
	free(ScreenBuffer);
        free(Palette24bppRed);
        free(Palette24bppGreen);
        free(Palette24bppBlue);       
}

static VOID    End16to16()
{
	free(ScreenBuffer);
}

static VOID    End16to15()
{
	free(ScreenBuffer);
	free(Palette15bpp);
}

static VOID    End16toFake()
{
	free(ScreenBuffer);
	free(PaletteFakeGreen);
	free(PaletteFakeRedBlue);
}

static VOID    End16to8()
{
	free(ScreenBuffer);
	free(Palette8bpp);
}


static VOID    End15to32()
{
	free(ScreenBuffer);
        free(Palette32bppRed);
        free(Palette32bppGreen);
        free(Palette32bppBlue);
}

static VOID    End15to24()
{
	free(ScreenBuffer);
        free(Palette24bppRed);
        free(Palette24bppGreen);
        free(Palette24bppBlue);
}

static VOID    End15to16()
{
	free(ScreenBuffer);
	free(Palette16bpp);
}

static VOID    End15to15()
{
	free(ScreenBuffer);
}

static VOID    End15to8()
{
	free(ScreenBuffer);
	free(Palette8bpp);
}

static VOID    End15toFake()
{
	free(ScreenBuffer);
	free(PaletteFakeGreen);
	free(PaletteFakeRedBlue);
}

static VOID    End8to32()
{
	free(ScreenBuffer);
	free(Palette32bpp);
}

static VOID    End8to24()
{
	free(ScreenBuffer);
	free(Palette24bpp);
}

static VOID    End8to16()
{
	free(ScreenBuffer);
	free(Palette16bpp);
}

static VOID    End8to15()
{
	free(ScreenBuffer);
	free(Palette15bpp);
}

static VOID    End8to8()
{
	free(ScreenBuffer);
}

VOID	InitStuff()
{
        
	ScreenBuffer=(UBYTE *) malloc(Active.Screen.ResolSize);

        if(ScreenBuffer==NULL)
	{
		Error_Code=1;
		ErrorMsg();
	}
	else
	{
		switch(Active.Work.bpp)
		{
			case	24:
				if(Active.Screen.bpp==32) 
				{
					Active.InitStuff=NULL;
					Active.EndStuff=End24to32;
				}

				if(Active.Screen.bpp==24) 
				{
					Active.InitStuff=NULL;
					Active.EndStuff=End24to24;
				}
				if(Active.Screen.bpp==16) 
				{
					Active.InitStuff=Init24to16;
					Active.EndStuff=End24to16;
				}
				if(Active.Screen.bpp==15) 
				{
					Active.InitStuff=Init24to15;
					Active.EndStuff=End24to15;
				}
				if(Active.Screen.bpp==8 )
				{
					Active.InitStuff=Init24to8;
					Active.EndStuff=End24to8;
				}

				if(Active.Screen.bpp==FAKEMODE)
				{
					Active.InitStuff=Init24toFake;
					Active.EndStuff=End24toFake;
				}
				break;

			case	16:
				if(Active.Screen.bpp==32) 
				{
					Active.InitStuff=Init16to32;
					Active.EndStuff=End16to32;
				}
				if(Active.Screen.bpp==24) 
				{
					Active.InitStuff=Init16to24;
					Active.EndStuff=End16to24;
				}
				if(Active.Screen.bpp==16) 
				{
					Active.InitStuff=NULL;
					Active.EndStuff=End16to16;
				}
				if(Active.Screen.bpp==15) 
				{
					Active.InitStuff=Init16to15;
					Active.EndStuff=End16to15;
				}
				if(Active.Screen.bpp==8)
				{
					Active.InitStuff=Init16to8;
					Active.EndStuff=End16to8;
				}
				if(Active.Screen.bpp==FAKEMODE)
				{
					Active.InitStuff=Init16toFake;
					Active.EndStuff=End16toFake;
				}
				break;

			case	15:
				if(Active.Screen.bpp==32) 
				{
					Active.InitStuff=Init15to32;
					Active.EndStuff=End15to32;
				}
				if(Active.Screen.bpp==24) 
				{
					Active.InitStuff=Init15to24;
					Active.EndStuff=End15to24;
				}
				if(Active.Screen.bpp==16) 
				{
					Active.InitStuff=Init15to16;
					Active.EndStuff=End15to16;
				}

				if(Active.Screen.bpp==15) 
				{
					Active.InitStuff=NULL;
					Active.EndStuff=End15to15;
				}

				if(Active.Screen.bpp==8)
				{
					Active.InitStuff=Init15to8;
					Active.EndStuff=End15to8;
				}
				if(Active.Screen.bpp==FAKEMODE)
				{
					Active.InitStuff=Init15toFake;
					Active.EndStuff=End15toFake;
				}
				break;

			case	8:
				if(Active.Screen.bpp==32) 
				{
					Active.InitStuff=Init8to32;
					Active.EndStuff=End8to32;
				}
				if(Active.Screen.bpp==24) 
				{
					Active.InitStuff=Init8to24;
					Active.EndStuff=End8to24;
				}
				if(Active.Screen.bpp==16) 
				{
					Active.InitStuff=Init8to16;
					Active.EndStuff=End8to16;
				}
				if(Active.Screen.bpp==15) 
				{
					Active.InitStuff=Init8to15;
					Active.EndStuff=End8to15;
				}

				if(Active.Screen.bpp==8)
				{
					Active.InitStuff=NULL;
					Active.EndStuff=End8to8;
				}
				break;	//...
		}
	}
}


static VOID    Set320x400()
{
	Set_Mode(0x13);	
	outpw(0x3C4,0x0604);
        outpw(0x3D4,0xE317);
        outpw(0x3D4,0x0014);
        outpw(0x3D4,0x4009);
        outpw(0x3C4,0x0f02);
	Clear_ScreenD(16384,0);
}

static VOID    Set320x480()
{
	Set_Mode(0x13);	        
        outpw(0x3C4,0x0604);
        outpw(0x3C4,0x0100);
        outp(0x3C2,0xE3);
        outpw(0x3c4,0x300);
        outp(0x3D4,0x11);
        outp(0x3D5,0x0E);
        outpw(0x3D4,0x0014);
        outpw(0x3D4,0xe317);
        outpw(0x3D4,0x0D06);
        outpw(0x3D4,0x3E07);
        outpw(0x3D4,0xEA10);
        outpw(0x3D4,0xAC11);
        outpw(0x3D4,0xDF12);
        outpw(0x3D4,0xE715);
        outpw(0x3D4,0x0616);
        outpw(0x3C4,0x0F02);
        outpw(0x3D4,0x2813);
        outp(0x3D4,0x9);
        outp(0x3D5,0);
	Clear_ScreenD(16384,0);
}

static VOID    Set640x400()
{
	if(!Get_Vesa_Info())	
	{
		ErrorMsg();
		Active.Screen.ResolSize=0;
	}
	else
	{
		Get_Modes_Info();
		#if !QUIETMODE
			Show_Modes_Info();
		#endif
	}
	if(!Set_Vesa_Mode(640,400,8,TRUE)) 
	{
		ErrorMsg();
		printf("Your card doesn't support 640x400x8 resolution. Try another fake mode.\n");
		Active.Screen.ResolSize=0;
	}
	else
	{
		Active.Screen.bpp=FAKEMODE; //Set_Vesa_Mode modifies this field ;-)
	}
}

static VOID    Set640x480()
{
	if(!Get_Vesa_Info())	
	{
		ErrorMsg();
		Active.Screen.ResolSize=0;
	}
	else
	{
		Get_Modes_Info();
		#if !QUIETMODE
			Show_Modes_Info();
		#endif
	}
	if(!Set_Vesa_Mode(640,480,8,TRUE)) 
	{
		ErrorMsg();
		Active.Screen.ResolSize=0;
	}
	else
	{
		Active.Screen.bpp=FAKEMODE; //Set_Vesa_Mode modifies this field ;-)
	}
}

VOID	ReloadPalette()
{
	if(Active.Work.bpp==8) 
	{
		switch(Active.Screen.bpp)
		{
			case 32:
				Calc8to32bppPal(Palette32bpp);
				break;
			case 24:
				Calc8to24bppPal(Palette24bpp);
				break;
			case 16:
				Calc8to16bppPal(Palette16bpp);
				break;
			case 15:
				Calc8to15bppPal(Palette15bpp);
				break;
			case 8:
				break;
		}

	}
}

#pragma	aux Set_Mode=\
"int	10h"\
modify	[ax]\
parm	[ax]

#pragma aux Clear_ScreenD=\
"MOV    EDI,0A0000H"\
"REP    STOSD"\
modify  [ECX EDI]\
parm    [ECX] [EAX]

//		    That's all folks     
//		If you are bored or depressed send me an email ;=)

