/******************************************************************************/
/*									      */
/*			    Vesa Library v1.1b 			      */
/*			     Optimized C version	 	      	      */
/*	Tab Size	: 8						      */
/*	Author		: Enric Agut					      */
/*	Nick   		: Dr. Pitch of SAVAGE				      */
/*	Date (Start)	: 05/9/98					      */
/*	Date (End)  	: 05/10/98					      */
/*	Comments 	: Altough this library is freeware, mail me if you    */
/*			  want to use it for your demos, utilities, games,... */
/*	Any suggestions (or any bug of this program) can be sent to: 	      */
/*		e7634217@est.fib.upc.es					      */
/*	Compiler & Linker : Watcom v10.5				      */
/*									      */
/*	Greetings jump to: all Savage members (Blue Phantom, Dr.Pain, FloOd,  */
/*	CCM, Smash!, Madknight & Wonder), Dr. Kami, Marathon Man, Falcon,     */
/*	Yacare, Sairf, Wally, Astharoth, ChC & Skirep.			      */
/*									      */
/*	Special thanks to:  Babyloon / Revelation; Blue Phantom / Savage;     */
/*	& Phil Jones							      */
/*									      */
/******************************************************************************/
#define __VESA
#include <stdio.h>
#include <stdlib.h>
#include <dos.h>
#include <conio.h>
#include <i86.h>
#include <string.h>
#include "vesalint.h"

/******************************************************************************/
/*									      */
/*Before this function is called, some fields of the Active Structure must    */
/*be set to a concrete value. These fileds are:				      */
/*	Screen.Width	: X resolution of the screen			      */
/*	Screen.Height	: Y resolution of the screen			      */
/*	Screen.bpp	: Bits per pixel of the screen			      */
/*									      */
/*	Work.Width	: X resolution of the "virtual" screen		      */	 
/*	Work.Height	: Y resolution of the "virtual" screen		      */
/*	Work.bpp	: Bits per pixel of the "virtual" screen	      */
/*	Enable.LFB	: TRUE -> Enable LFB if available      		      */
/*			  FALSE -> Not enable LFB although available          */
/*									      */
/*	Palette		: the palette you want to set 			      */
/*			  (if you work & draw at 8 bpp)	     		      */
/******************************************************************************/

BOOL    InitSetMode()
{
	UWORD	col;
	BOOL	nret;

	/* Credits */
	printf(" Vesa library v1.1b by Dr. Pitch / SAVAGE\n");
	printf("  Big hellos to all savage members!\n");
	Wait();
	/* End of Credits */

        if((Active.Screen.bpp!=8 && Active.Screen.bpp!=15 && 
	Active.Screen.bpp!=16 && Active.Screen.bpp!=24 && 
	Active.Screen.bpp!=32 && Active.Screen.bpp!=FAKEMODE) ||
	(Active.Work.bpp!=8 && Active.Work.bpp!=15 && 
	Active.Work.bpp!=16 && Active.Work.bpp!=24) ||
        (Active.Work.bpp==8 && Active.Screen.bpp==FAKEMODE))
	{
		Error_Code=7;
		ErrorMsg();
		nret=FALSE;
	}
	else
	{
		if(Active.Screen.bpp==FAKEMODE)
		{
			nret=FakeSystem();
		}
		else
		{
			nret=VesaSystem();
		}
	}
	if(nret)
	{
		if(Active.Work.bpp==8 && Active.Screen.bpp==8) 
		{
			outp(0x3c8,0);
			for(col=0;col<256;++col)
			{
				outp(0x3c9,Active.Palette[col].r);
				outp(0x3c9,Active.Palette[col].g);
				outp(0x3c9,Active.Palette[col].b);
			}
		}
	}

	return(nret);
}


VOID	far *Dos_Alloc(POINTER *In, UDWORD bytes)
{
	union REGS	regs;
	VOID 		far *Ret=NULL;
	UDWORD		paragraphs;

	//Number of Paragraphs=Number of bytes/16 (+15 to round up)
	paragraphs=(bytes+15)>>4;		

	//Allocate memory
	memset(&regs,0,sizeof(regs));
	regs.x.eax=0x0100;
	regs.x.ebx=paragraphs;
	int386(0x31,&regs,&regs);

	//All right??
	if(regs.x.cflag==0)
	{
		In->segment=regs.w.ax;
		In->selector=regs.w.dx;	
		In->memAlloc=paragraphs<<4;
		//Make a far pointer	
		Ret=MK_FP(In->selector,0);
		
		#if !QUIETMODE
			printf("%u bytes allocated.\n",In->memAlloc);
		#endif
	}
	else
	{
		Error_Code=1;
	}
	
	return(Ret);
}

BOOL	Dos_Dealloc(POINTER *In)
{
	union REGS	regs;
	BOOL		Ret=FALSE;

	//free memory block
	memset(&regs,0,sizeof(regs));
	regs.x.eax=0x0101;
	regs.x.edx=In->selector;
	int386(0x31,&regs,&regs);

	//All right??
	if(regs.x.cflag==0)
	{
		#if !QUIETMODE
			printf("%u bytes deallocated.\n",In->memAlloc);
		#endif

		Ret=TRUE;
	}
	else
	{
		Error_Code=2;
	}
	return(Ret);	
}

VOID	Real_Int(UDWORD nint, RMREGS *rmregs)
{
	union REGS	regs;
	struct SREGS	sregs;

	memset(&regs,0,sizeof(regs));
	memset(&sregs,0,sizeof(sregs));
	segread(&sregs);

	regs.x.eax=0x300;
	regs.x.ebx=nint;
	regs.x.ecx=0;
	sregs.es=FP_SEG(rmregs);
	regs.x.edi=FP_OFF(rmregs);
	int386x(0x31,&regs,&regs,&sregs);
}

BOOL	Get_Vesa_Info()
{
	RMREGS		rmregs;
	BOOL		Ret=FALSE;

	if((Vesa_Info=(VESAINFO far *) Dos_Alloc(&Vesa_Info_Ptr,sizeof(VESAINFO)))!=NULL)
	{
		//Fill the Signature with VBE2 to get the VBE 2.0 info if possible
		Vesa_Info->Signature[3]='V';
		Vesa_Info->Signature[2]='B';
		Vesa_Info->Signature[1]='E';
		Vesa_Info->Signature[0]='2';

		memset(&rmregs,0,sizeof(rmregs));
		rmregs.eax=0x4f00;
		rmregs.es=Vesa_Info_Ptr.segment;
		rmregs.edi=0;
		Real_Int(0x10,(RMREGS *) &rmregs);
		if(rmregs.eax==0x4f) 
		{
			Ret=TRUE;
		}
		else
		{
			Error_Code=3;
		}
                       //Xratio and Yratio for fake modes are calculated later.
			if(Active.Screen.bpp!=FAKEMODE)
			{
				if(Active.Screen.Width!=0)	Active.XRatio=65536*Active.Work.Width/Active.Screen.Width;
				if(Active.Screen.Height!=0)	Active.YRatio=65536*Active.Work.Height/Active.Screen.Height;
			}	
	}
	return(Ret);
}

BOOL	Free_Memory()
{
	union REGS	regs;
	BOOL 		Ret=TRUE;

	if(Vesa_Mode_Info!=NULL)
	{
		if(((Vesa_Mode_Info->ModeAttributes&128)>>7) && Active.EnableLFB==TRUE)
		{
			memset(&regs,0,sizeof(regs));
			regs.x.eax=0x801;
			regs.w.bx=ScreenAddress>>16;
			regs.w.cx=ScreenAddress%65536;
			int386(0x31,&regs,&regs);
			/*if(regs.x.cflag)
			{
				Error_Code=8;
				Ret=FALSE;
			}*/
		}
	}

	if(Active.EndStuff!=NULL)	Active.EndStuff();
	if(Vesa_Info!=NULL)		Ret&=Dos_Dealloc(&Vesa_Info_Ptr);
	if(Vesa_Mode_Info!=NULL)	Ret&=Dos_Dealloc(&Vesa_Mode_Info_Ptr);
	return(Ret);
}

VOID	ErrorMsg()
{
	Set_Mode(0x3);
	switch(Error_Code)
	{
		case 1:
			printf("Memory can not be allocated.\n");
			break;

		case 2:
			printf("Memory can not be deallocated.\n");
			break;

		case 3:
			printf("Vesa not supported.\n");
			break;

		case 4:
			printf("Vesa Mode specified not found.\n");
			break;

		case 5:
			printf("Linear Frame Buffer can't be mapped.\n");
			break;
		case 6:
			printf("Invalid Fake Mode.\n");
			printf("Read the vesa.nfo for more information.\n");
			break;
		case 7:
                        printf("Invalid Bits per Pixel Mode or invalid bpp/workbpp combination.\n");
			printf("Read the vesa.nfo for more information.\n");
			break;
		/*case 8:
			printf("Linear Frame Buffer can't be unmapped.\n");
			break;	//...		
		*/

	}
	Wait();
}

VOID	Get_Modes_Info()
{
	RMREGS	rmregs;
	UDWORD	Vesa_Mode;
	SWORD	NumModes=-1;
	UDWORD	TotalBytes;

	if((Vesa_Mode_Info=(VESAMODEINFO far *) Dos_Alloc(&Vesa_Mode_Info_Ptr,sizeof(VESAMODEINFO)))!=NULL)
	{

		for(Vesa_Mode=0x100;Vesa_Mode<0x200;++Vesa_Mode)
		{
			memset(&rmregs,0,sizeof(rmregs));
			rmregs.eax=0x4f01;
			rmregs.ecx=Vesa_Mode;
			rmregs.es=Vesa_Mode_Info_Ptr.segment;
			rmregs.edi=0;
			Real_Int(0x10,(RMREGS *) &rmregs);
			TotalBytes=(Vesa_Mode_Info->PixelWidth*Vesa_Mode_Info->PixelHeight*Vesa_Mode_Info->BitsPerPixel)>>3;
                        if(rmregs.eax==0x4f && (Vesa_Mode_Info->ModeAttributes&16) && TotalBytes<=(Vesa_Info->TotalMemory<<16))
			{
				NumModes++;
				Vesa_Modes[NumModes].Width=Vesa_Mode_Info->PixelWidth;
				Vesa_Modes[NumModes].Height=Vesa_Mode_Info->PixelHeight;
				Vesa_Modes[NumModes].bpp=Vesa_Mode_Info->BitsPerPixel;
				Vesa_Modes[NumModes].Mode=Vesa_Mode;

				if(Vesa_Modes[NumModes].bpp>8) //Some cards don't fill the bpp field correctly!
				{
	                                Vesa_Modes[NumModes].RedPos=Vesa_Mode_Info->RedFieldPosition;
        	                        Vesa_Modes[NumModes].GreenPos=Vesa_Mode_Info->GreenFieldPosition;
                	                Vesa_Modes[NumModes].BluePos=Vesa_Mode_Info->BlueFieldPosition;
					Vesa_Modes[NumModes].bpp=Vesa_Mode_Info->RedMaskSize+Vesa_Mode_Info->GreenMaskSize+Vesa_Mode_Info->BlueMaskSize;
				}
				if((Vesa_Mode_Info->BytesPerScanLine>>2)==Vesa_Mode_Info->PixelWidth) 
				{
					Vesa_Modes[NumModes].bpp=32;
				}
			}
		}
		Vesa_Modes[NumModes+1].Mode=-1;		//to detect the end
	}
}

VOID	Show_Modes_Info()
{
	UWORD	NumModes=0;
	UWORD	Line=0;
	
	printf("\n");
	while(Vesa_Modes[NumModes].Mode!=-1)
	{
		printf(" 0x%x: %u x %u x %u ",Vesa_Modes[NumModes].Mode,Vesa_Modes[NumModes].Width,Vesa_Modes[NumModes].Height,Vesa_Modes[NumModes].bpp);
       		printf("       R:%u  G:%u  B:%u \n",Vesa_Modes[NumModes].RedPos,Vesa_Modes[NumModes].GreenPos,Vesa_Modes[NumModes].BluePos);
		++NumModes;
		++Line;		
		if(Line==20)
		{
			Wait();
			Line=0;
		}
	}
	printf("\nGraphics available modes : %u\n\n",NumModes);
	Wait();
}

/******************************************************************************/
/*									      */
/*	  			SET_VESA_MODE FUNCTION			      */
/*	iN: 								      */	
/*		Width  = Width Screen of VESA mode we want to set	      */
/*		Height = Height Screen of VESA mode we want to set	      */
/*		bpp    = Bits per pixel of VESA mode we want to set	      */
/*		LFB    = Set it to TRUE if you want to use LFB if available   */	
/*	oUT: 								      */	
/*		FALSE on error						      */
/*									      */
/******************************************************************************/
BOOL	Set_Vesa_Mode(UWORD Width, UWORD Height, UWORD bpp, BOOL LFB)
{
	UWORD	NumModes=0;
	BOOL	Ret=FALSE;
	union	REGS regs;
	RMREGS	rmregs;
	BOOL	bLFB;
	UWORD	bppmod;
	UDWORD	Linear_Address;
	UWORD	*Ptr;
	BOOL	InternalSwitching=FALSE;
	UWORD	PortsMemOffset,BankProcOffset;
	SWORD	bppScreen=Active.Screen.bpp;

	//look for the specified mode
	while(Vesa_Modes[NumModes].Mode!=-1)
	{
		if(Vesa_Modes[NumModes].Width==Width &&
		   Vesa_Modes[NumModes].Height==Height &&
		   Vesa_Modes[NumModes].bpp==bpp)
		{	
			Ret=TRUE;
			break;			
		}
		++NumModes;
	}
	
	//if found...	
	if(Ret)
	{
		#if !QUIETMODE
			printf("Mode: 0x%x\n",Vesa_Modes[NumModes].Mode);
		#endif
		memset(&rmregs,0,sizeof(rmregs));
		rmregs.eax=0x4f01;
		rmregs.ecx=Vesa_Modes[NumModes].Mode;
		rmregs.es=Vesa_Mode_Info_Ptr.segment;
		rmregs.edi=0;
		Real_Int(0x10,(RMREGS *) &rmregs);

		Active.Screen.Width=Vesa_Modes[NumModes].Width;
		Active.Screen.Height=Vesa_Modes[NumModes].Height;
		Active.Screen.bpp=Vesa_Modes[NumModes].bpp;
                Active.RedShift=Vesa_Modes[NumModes].RedPos;
		Active.GreenShift=Vesa_Modes[NumModes].GreenPos;
		Active.BlueShift=Vesa_Modes[NumModes].BluePos;

		bppmod=Active.Work.bpp;
		//increment the bpp if it's equal to 15 to calculate the ResolSize field correctly
		if(bppmod%2!=0) bppmod++;	
		Active.Work.ResolSize=(Active.Work.Width*Active.Work.Height*bppmod)>>3;

		bppmod=Vesa_Modes[NumModes].bpp;
		if(bppmod%2!=0) bppmod++;
		Active.Screen.ResolSize=(Vesa_Modes[NumModes].Width*Vesa_Modes[NumModes].Height*bppmod)>>3;

		bLFB=(Vesa_Mode_Info->ModeAttributes&128)>>7;
		if(bLFB) 
		{
			Linear_Address=(Vesa_Mode_Info->PhysicalBaseSegment<<16)+Vesa_Mode_Info->PhysicalBaseOffset;
		}

		if(bLFB && LFB==TRUE)
		{
			#if !QUIETMODE
				printf(" LFB (Linear Frame Buffer) available.\n");
			#endif

			Active.FlipVideo=Flip_LFB;

			memset(&regs,0,sizeof(regs));
			regs.x.eax=0x800;
			regs.w.bx=Vesa_Mode_Info->PhysicalBaseSegment;
			regs.w.cx=Vesa_Mode_Info->PhysicalBaseOffset;
			regs.w.si=Active.Screen.ResolSize/65536;
			regs.w.di=Active.Screen.ResolSize%65536;
			int386(0x31,&regs,&regs);
			if(!regs.x.cflag)
			{
				ScreenAddress=(regs.w.bx<<16)+regs.w.cx;

				memset(&regs,0,sizeof(regs));
				regs.x.eax=0x4f02;
				regs.x.ebx=Vesa_Modes[NumModes].Mode+0x4000;	
				int386(0x10,&regs,&regs);
			}
			else
			{
				Error_Code=5;
				Ret=FALSE;
			}
		}
		else
		{
			#if !QUIETMODE
				printf(" LFB (Linear Frame Buffer) no available.\n");
			#endif

			ScreenAddress=Vesa_Mode_Info->StartSegmentWindowA<<4;
			Active.NumBanks=Active.Screen.ResolSize/(Vesa_Mode_Info->WindowSize<<10);
			if(Active.Screen.ResolSize%65536!=0) ++Active.NumBanks;
			Active.NextBank=Vesa_Mode_Info->WindowSize/Vesa_Mode_Info->WindowGranularity;
			Active.FlipVideo=Flip_Banked;

			memset(&rmregs,0,sizeof(rmregs));
			rmregs.eax=0x4f0a;
			rmregs.ebx=0;
			Real_Int(0x10,&rmregs);
			if(rmregs.eax!=0x4f)
			{
				#if !QUIETMODE
					printf(" 32 bits switch bank interface not detected.\n");
				#endif
			}
			else
			{
				Linear_Address=(rmregs.es<<4)+(rmregs.edi&0xffff);
				Ptr= (UWORD *) Linear_Address;
				PortsMemOffset=*(Ptr+3);

				//If "Ports & memory list" offset is 0 (it means there's no list) then Internal Bank Switch is available
				if(PortsMemOffset==0)
				{
					InternalSwitching=TRUE;
				}
				else
				{
					//Skip Port List
					while(*Ptr!=0xffff) ++Ptr;	
					++Ptr;				
					//If length of Memory list is 0 then Internal Bank Switch is available
					if(*Ptr==0xffff) InternalSwitching=TRUE;
				}
			}
			if(InternalSwitching) 
			{
				Ptr= (UWORD *) Linear_Address;
				BankProcOffset=*Ptr;
				BankSwitchPtr=Linear_Address+BankProcOffset;
				SetBank=Internal_Bank_Switch;
				#if !QUIETMODE
					printf(" Internal Bank switch available.\n");	
				#endif
			}
			else
			{
				SetBank=Manual_Bank_Switch;
				#if !QUIETMODE
					printf(" Internal Bank switch no available.\n");
				#endif
			}
			#if !QUIETMODE
				Wait();
			#endif

			memset(&regs,0,sizeof(regs));
			regs.x.eax=0x4f02;
			regs.x.ebx=Vesa_Modes[NumModes].Mode;	
			int386(0x10,&regs,&regs);
		}

		if(Ret && bppScreen!=FAKEMODE)
		{
			InitStuff();
			if(Active.InitStuff!=NULL) Active.InitStuff();
		}

	}
	else
	{
		Error_Code=4;
	}
	return(Ret);
}

VOID	Flip_Banked(UBYTE *WorkBuffer)
{
	UWORD	n,Bank;
	UDWORD	Total;
	UBYTE	*ScreenBufferCopy;	

	ScreenBufferCopy=ScreenBuffer;

	Bank=0;
	Total=Active.Screen.ResolSize;

	if(Active.Work.bpp!=Active.Screen.bpp || (Active.Work.bpp==Active.Screen.bpp && (Active.XRatio!=65536 || Active.YRatio!=65536)))
	{
		Transform_bpp(Active.Work.bpp,Active.Screen.bpp,WorkBuffer,ScreenBuffer); 

		for(n=0;n<Active.NumBanks;++n)
		{
			SetBank(Bank);
			FlipBuc(ScreenBufferCopy,Total);
			ScreenBufferCopy+=65536;
			Total-=65536;
			Bank+=Active.NextBank;
		}
	}
	else
	{
		for(n=0;n<Active.NumBanks;++n)
		{
			SetBank(Bank);
			FlipBuc(WorkBuffer,Total);
			WorkBuffer+=65536;
			Total-=65536;
			Bank+=Active.NextBank;
		}
	}
}

VOID	FlipBuc(UBYTE *Buffer,UDWORD Total)
{
	if(Total>=65536)
	{
		Flip_ScreenD(Buffer,65536>>2);
	}
	else
	{
		if(Total%4==0)
		{
			Flip_ScreenD(Buffer,Total>>2);
		}
		else if(Total%2==0)
		{
			Flip_ScreenW(Buffer,Total>>1);
		}
		else
		{
			Flip_ScreenB(Buffer,Total);
		}
	}
}

VOID	Flip_LFB(UBYTE *WorkBuffer)
{
	if(Active.Work.bpp!=Active.Screen.bpp || (Active.Work.bpp==Active.Screen.bpp && (Active.XRatio!=65536 || Active.YRatio!=65536)))
	{
		Transform_bpp(Active.Work.bpp,Active.Screen.bpp,WorkBuffer,ScreenBuffer); 
		Flip_ScreenD(ScreenBuffer,Active.Screen.ResolSize>>2);
	}
	else
	{
		Flip_ScreenD(WorkBuffer,Active.Screen.ResolSize>>2);
	}
}

VOID	Flip_Fake_X(UBYTE *WorkBuffer)
{
	UWORD	x,y,WidthDiv4;
	UDWORD	Pos,Pos2;

	Transform_bpp(Active.Work.bpp,Active.Screen.bpp,WorkBuffer,ScreenBuffer);

	for(x=0;x<Active.Screen.Width;++x)
	{
		outp(0x3c4,2);
		outp(0x3c5,1<<(x&3));
		Pos=x>>2;
		Pos2=x;
		WidthDiv4=(Active.Screen.Width)>>2;
		for(y=0;y<Active.Screen.Height;y++)
		{
			Screen[Pos]=ScreenBuffer[Pos2];
			Pos+=WidthDiv4;
			Pos2+=Active.Screen.Width;
		}
	}
}

VOID	Flip(UBYTE *Buffer)
{
	(*Active.FlipVideo) (Buffer);
}

VOID 	Manual_Bank_Switch(UWORD NumBank)
{
	union 	REGS regs;

	memset(&regs,0,sizeof(regs));
	regs.x.eax=0x4f05;
	regs.x.ebx=0;
	regs.w.dx=NumBank;
	int386(0x10,&regs,&regs);
}

VOID	Internal_Bank_Switch(UWORD nBank)
{
	InterBank(nBank);
}


#pragma	aux InterBank=\
"MOV	EAX,4F05H"\
"XOR	EBX,EBX"\
"CALL	DWORD PTR [BankSwitchPtr]"\
modify	[EAX EBX ECX EDX ESI EDI]\
parm	[DX]


#pragma	aux Flip_ScreenD=\
"MOV	EDI,[ScreenAddress]"\
"REP	MOVSD"\
modify	[ECX ESI EDI]\
parm	[ESI] [ECX]

#pragma	aux Flip_ScreenW=\
"MOV	EDI,[ScreenAddress]"\
"REP	MOVSW"\
modify	[ECX ESI EDI]\
parm	[ESI] [ECX]

#pragma	aux Flip_ScreenB=\
"MOV	EDI,[ScreenAddress]"\
"REP	MOVSB"\
modify	[ECX ESI EDI]\
parm	[ESI] [ECX]

VOID	Wait()
{
	while(kbhit()) getch();
	printf("Press any key to continue...\n");
	getch();
}

BOOL    VesaSystem()
{
	BOOL    nret=TRUE;

	if(!Get_Vesa_Info())
	{
		ErrorMsg();	
		nret=FALSE;
	}
	else
	{
		Get_Modes_Info();
                #if !QUIETMODE
                        Show_Modes_Info();
                #endif
		if(!Set_Vesa_Mode(Active.Screen.Width,Active.Screen.Height,Active.Screen.bpp,Active.EnableLFB))
		{
			ErrorMsg();
			nret=FALSE;
		}
	}
	return(nret);
}

BOOL	FakeSystem()
{
	UWORD	bppmod;
	BOOL	nret=TRUE;

	FakeMode=-1;
	if(Active.Screen.Width==320 && (Active.Screen.Height==200 || Active.Screen.Height==240))
	{
		Active.Screen.Height*=2;
	}
	else if(Active.Screen.Width==320 && (Active.Screen.Height==400 || Active.Screen.Height==480))
	{
		Active.Screen.Width*=2;
	}

	Active.Screen.ResolSize=Active.Screen.Width*Active.Screen.Height;

	bppmod=Active.Work.bpp;
	if(bppmod%2!=0) bppmod++;
	Active.Work.ResolSize=(Active.Work.Width*Active.Work.Height*bppmod)>>3;

	InitStuff();
	if(Active.InitStuff!=NULL) Active.InitStuff();


	if(Active.Screen.ResolSize!=0) //if has occured an error ResolSize=0.
	{
		if(FakeMode==m320x400 || FakeMode==m320x480)
		{
			Active.XRatio=65536*Active.Work.Width/Active.Screen.Width;
			Active.YRatio=65536*Active.Work.Height/(Active.Screen.Height/2);
			Active.FlipVideo=Flip_Fake_X;
		}
		else if(FakeMode==m640x400 || FakeMode==m640x480)
		{
			Active.XRatio=65536*Active.Work.Width/(Active.Screen.Width/2);
			Active.YRatio=65536*Active.Work.Height/Active.Screen.Height;
		}
		else
		{
			//Invalid Fake mode
			Error_Code=6;
			ErrorMsg();
			nret=FALSE;
		}
        }
        else
        {
                nret=FALSE;
        }
        return(nret);
}

#pragma	aux Set_Mode=\
"int	10h"\
modify	[ax]\
parm	[ax]

